;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ;          #include <P16F628A.INC>
         #include <P16F648A.INC>
   ;           LIST        p=16F628A     
          LIST        p=16F648A 
;  -        __CONFIG    H'3F18'           ;   B'__11_1111_0001_1000'
;--------------------------------------------------------------------------------------------------
; INTOSC oscillator, RA6 = I/O function, RA7 = I/O function 
; Watchdog Timer - Disable
; Power-up Timer - Disable
; MCLRE - RA5 Function Select bit - I/O
; BOREN - Brown-Reset - Disable
; LVP - Low-Voltage Programming - Disable
; inv CPD - Data Code Protection - Disable
; bit 12-9 -unimplemented, read as '0',   '1'
; inv CP - Code Protection Program Memory - Disable
;--------------------------------------------------------------------------------------------------
;;;       ,    ' 
;;;      (PIC16F648.INC)
;--------------------------------------------------------------------------------------------------
; :
	__CONFIG _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_OFF & _CP_OFF & _WDT_ON & _PWRTE_ON
; ² WDTE - Watchdog Timer

;	__CONFIG _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_OFF & _CP_OFF & _WDT_OFF & _PWRTE_ON
;    !!! WDTE - Watchdog Timer


;*****************************************************************************************************
; unprogramed bits read as '1'
; bit 13 - inv CP - Code Protection Program Memory
; bit 12-9 -unimplemented, read as '0'
; bit 8 - inv CPD - Data Code Protection
; bit 7 - LVP - Low-Voltage Programming (if='0' RB4 is digital I/O, inv MCLR Programming enabled
; bit 6 - BOREN - Brown-Reset Enable bit
; bit 5 - MCLRE - RA5 Function Select bit ('1' - pin function is inv MCLR )
;          When inv MCLR is asserted in INTOSC mode, the internal clock oscillator is disabled
;;;   " " inv MCLR  in INTOSC mode, the internal clock oscillator is disabled 
; bit 3 - inv PWRTE - Power-up Timer Enabled
; bit 2 - WDTE - Watchdog Timer Enable bit
; bit 4, bit 1, bit 0 - 
;        111 - RC oscillator, RA6 = CLOCKOUT (RC on RA7)
;        110 - RC oscillator, RA6 = I/O function (RC on RA7)       
;        101 - INTOSC oscillator, RA6 = CLOCKOUT, RA7 = I/O function        
;        100 - INTOSC oscillator, RA6 = I/O function, RA7 = I/O function         
;        011 - EC, RA6 = I/O function, RA7 = CLOCKIN - ղ !!!
;        010 - HS oscillator (RA6,RA7 - Crystall)
;        001 - XT oscillator (RA6,RA7 - Crystall)
;        000 - LP oscillator (RA6,RA7 - Crystall)
;******************************************************************************************************

;² , Ͳ   Ҳ ̲ в,    .ASM
	include  "KOROTKO.inc"
               errorlevel  -302, -307, -202              ;     302, 307. 202  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 0-   80 òв + 16 ϲ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
nomer         equ         0023h             ;   ascii 
scetbit       equ         0024h             ;  -   
perem         equ         0025h             ;  /   spi, i2c                
temp          equ         0026h             ;  
tmp_symb      equ         0027h             ;      
oss           equ         0028h             ;      
tmp_tab   equ  0029h

DIGIT1        equ         0030h             ;     
DIGIT2        equ         0031h             ;   
DIGIT3        equ         0032h
DIGIT4        equ         0033h
DIGIT5        equ         0034h          
DIGIT6        equ         0035h
DIGIT7        equ         0036h
DIGIT8        equ         0037h
DIGIT9        equ         0038h
DIGIT10       equ         0039h
count_1       equ         003Ah
count_2       equ         003Bh
bin_HH        equ         003Ch
bin_HL        equ         003Dh
bin_LH        equ         003Eh
bin_LL        equ         003Fh


adr_i2c       equ         0040h             ;     i2c
tmp_i2c       equ         0041h
slave_adr     equ         0042h
data_i2c      equ         0043h

;;   0     !!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;VidlVys_HL		equ			0044h			;    ò    
;VidlVys_LL		equ			0045h			;    ò    
;VidlVys_LH		equ			0046h			;      

RezT1		equ			0047h			;    1,2,3...24   
RezT2		equ			0048h
RezT3		equ			0049h
RezT4		equ			004Ah
RezT5		equ			004Bh
RezT6		equ			004Ch
RezT7		equ			004Dh
RezT8		equ			004Eh
RezT9		equ			004Fh

RezT10		equ			0050h          
RezT11		equ			0051h
RezT12		equ			0052h
RezT13		equ			0053h	
RezT14		equ			0054h          
RezT15		equ			0055h
RezT16		equ			0056h
RezT17		equ			0057h
RezT18		equ			0058h
RezT19		equ			0059h
RezT20		equ			005Ah
RezT21		equ			005Bh
RezT22		equ			005Ch
RezT23		equ			005Dh
RezT24		equ			005Eh

KONTR_REG		equ			005Fh					;  ò,   :
;*************************************************************************************************
;  		; 0 - 0/1 -     /   ...
;  		;;;;;;;;;; 1 - 0/1 -   / ² 
					;;;;;;;;;; 2 - 0/1 -  ""  / ²
					; 3 - 0/1 -   /  ²  ""
	;(   ²  "",  ( bit=1)     )
					; 4 - 0/1 -      ("-") / ("+")
					; 5 - 0/1 -   /       
					; 6 - 0/1 -	      /   ("+"  "-")
					; 7 - 0/1 -    "ϳ "  ² / ²
;*************************************************************************************************

CYKL				equ			0060h 		;     
KilPerWDT			equ			0061h	;    WDT,  ,    5 
										; 0,028  128 (.  )  130 = 299,52 = . 5.
;VidlVys_LL			equ			0062h	;       
VidlVys_LH			equ			0063h			;      
PotRezVymT			equ			0064h	;       .  (= -700 . .)
RezMynGodyny		equ			0065h	;      (  = -700 . .) (  )
ByteGraf			equ			0066h	;   
GodynaZhvylyn		equ			0067h	;     5- 
TEMP1				equ			0068h	;      

VidlikGraf			equ			0069h	; ,    ,
										;        в Ĳֲ
VidlVys_LL			equ			006Ah	;   0

;   òв   "" 
;Y_GRAF		equ			006Bh	;   Y- Բ
;VidlVys_LH		equ			006Ch	;      
;VidlVys_LL		equ			006Dh	;      
;TEMP_LH		equ			006Eh
;TEMP_LL		equ			006Fh

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ϲͲ 16 òв  Ѳ  ʲ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
										;  ֳ    PIC15F627A 628A 648A
										;  ϲ    
SPBLichylxnykIMP	EQU		0070h		; Ѳ ʲ       -
SPBPerer1			EQU		0071h		; Ѳ ʲ ,     (INT - SvZvIndImp . )
SPBPerer2			EQU		0072h		; Ѳ ʲ ,     (INT - SvZvIndImp . )
SPBPotFSR			EQU		0073h		; Ѳ ʲ  -   FSR   
SPBPerer3		equ			0074h		; Ѳ ʲ ,     (INT - SvZvIndImp . )

;SPBTemp_HL		equ			0075h	;  Ѳ ʲ  
;SPBTemp_LH		equ			0076h	;  Ѳ ʲ  
;SPBTemp_LL		equ			0077h	;  Ѳ ʲ  
SPBREG_IND		equ			0078h	; Ѳ ʲ   ,   : 
;*************************************************************************************************
;  		; 0 - 0/1 -   / ² 
;  		; 1 - 0/1 -     / 
					; 2 - 0/1 -  ""  / ²
					; 3 - 0/1 -   /   
					; 4 - 0/1 - 
					; 5 - 0/1 - 
					; 6 - 0/1 -  
					; 7 - 0/1 -  
;*************************************************************************************************
SPBW_TMP					equ		0079h  	;    W     
SPBSTATUS_TMP				equ		007Ah	;    STATUS     

; OPTION_TMP				equ		007Bh	;    OPTION_REG     

SPBSTOR_POVERN		EQU		0062h	;         '
											;       ,  .
SPBSTOR_POVERN_TMP	EQU		007Ch	;         '
											;       ,  .
SPBFixatorIMP		EQU		007Dh	; Ѳ ʲ ,     -21  
									;    WDT     ,          
									;  ""   SLEEP     .
SPBKONTR_REGRR		EQU		007Eh			;;  ò   ̲ в Ĳֲ,   :
;*************************************************************************************************
;  		; 0 - 0/1 -   "" /  " " (,  SPBKONTR_REGRR,1 = "1") 
;  		; 1 - 0/1 -   ""  /  " "    
					; 2 - 0/1 -  ϲ (  . 1-    ) /   ( )
					; 3 - 0/1 -   /  1-  (50/)    
					; 4 - 0/1 -   /  2-  (255/)   
					; 5 - 0/1 -   / в     2-  (255/)
					; 6 - 0/1 -   ² / ²  䳿   "в Ĳֲ - "
					; 7 - 0/1 -   ² / ²  䳿   " "
;*************************************************************************************************
flag          equ         007Fh             ;   ;;;    0- !!!
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 0 ʲӪ  007Fh
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 1-   80 òв + 16 ϲ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AC1_LH        equ         00A0h             ;     BMP180
AC1_LL        equ         00A1h
AC2_LH        equ         00A2h
AC2_LL        equ         00A3h
AC3_LH        equ         00A4h
AC3_LL        equ         00A5h
AC4_LH        equ         00A6h
AC4_LL        equ         00A7h
AC5_LH        equ         00A8h
AC5_LL        equ         00A9h


AC6_LH        equ         00AAh
AC6_LL        equ         00ABh
B1_LH         equ         00ACh
B1_LL         equ         00ADh
B2_LH         equ         00AEh
B2_LL         equ         00AFh
MB_LH         equ         00B0h
MB_LL         equ         00B1h
MC_LH         equ         00B2h
MC_LL         equ         00B3h


MD_LH         equ         00B4h
MD_LL         equ         00B5h

X1_HH         equ         00B6h             ;        BMP180
X1_HL         equ         00B7h
X1_LH         equ         00B8h
X1_LL         equ         00B9h
X2_HH         equ         00BAh
X2_HL         equ         00BBh
X2_LH         equ         00BCh
X2_LL         equ         00BDh


X3_HH         equ         00BEh
X3_HL         equ         00BFh
X3_LH         equ         00C0h
X3_LL         equ         00C1h
B3_HH         equ         00C2h
B3_HL         equ         00C3h
B3_LH         equ         00C4h
B3_LL         equ         00C5h
B5_HH         equ         00C6h
B5_HL         equ         00C7h


B5_LH         equ         00C8h
B5_LL         equ         00C9h
B4_HH         equ         00CAh
B4_HL         equ         00CBh
B4_LH         equ         00CCh
B4_LL         equ         00CDh
B6_HH         equ         00CEh
B6_HL         equ         00CFh
B6_LH         equ         00D0h
B6_LL         equ         00D1h


REGA3         equ         00D2h
REGA2         equ         00D3h
REGA1         equ         00D4h
REGA0         equ         00D5h
REGB3         equ         00D6h
REGB2         equ         00D7h
REGB1         equ         00D8h
REGB0         equ         00D9h
REGC3         equ         00DAh
REGC2         equ         00DBh


REGC1         equ         00DCh
REGC0         equ         00DDh
MTEMP         equ         00DEh
MCOUNT        equ         00DFh

P_HH          equ         00E0h             ;   
P_HL          equ         00E1h
P_LH          equ         00E2h
P_LL          equ         00E3h

P_M           equ         00E4h             ;      ..
P_L           equ         00E5h


T_HH          equ         00E6h             ;   
T_HL          equ         00E7h
T_LH          equ         00E8h
T_LL          equ         00E9h
 
tmp           equ         00EAh             ;  
y_adr     equ     00EBh;
x_adr      equ     00ECh;

Y_GRAF			EQU		00EDh	;   Y- Բ
; B1OPTION_TMP	EQU		00EEh	;    OPTION_REG     

; B180			EQU			00EFh	;	Ĳ ò  1
;;; 1 ʲӪ  	00EFh          
;;; (ϲ ֲ   16 òв ϲ   Ѳ 4- ( 0-  3-) ʲ)
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 2-   80 òв + 16 ϲ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
B2VymRR1			EQU		0120h		;   ̲в
B2VymRR2			EQU		0121h		; в Ĳֲ 
B2VymRR3			EQU		0122h		;  
B2VymRR4			EQU		0123h		; 125. = 60 = 1 
B2VymRR5			EQU		0124h		;
B2VymRR6			EQU		0125h		;
B2VymRR7			EQU		0126h		;
B2VymRR8			EQU		0127h		;
B2VymRR9			EQU		0128h		;
B2VymRR10			EQU		0129h		;

B2VymRR11			EQU		012Ah		;
B2VymRR12			EQU		012Bh		;
;-----------------------------------------------------------------
B2SerRR				EQU		012Ch		;       ,  
B2KilxkVymRR		EQU		012Dh		;    ,   (. = 12)
B2NomerRegZapRR		EQU		012Eh		;       
B2SumaVymRRG_ST		EQU		012Fh		;        
B2SumaVymRRG_ML		EQU		0130h		;        

CYKLB2			EQU		0131h		;         
TEMPB2			EQU		0132h		;       
TEMPB2_ST		EQU		0133h		;       
TEMPB2_ML		EQU		0134h		;       

B2SerRR1GT		EQU		0135h		;    1  
B2SerRR2GT		EQU		0136h		;    2  
B2SerRR3GT		EQU		0137h		;    3  
B2SerRR4GT		EQU		0138h		;    4  
B2SerRR5GT		EQU		0139h		;    5  
B2SerRR6GT		EQU		013Ah		;    6  
B2SerRR7GT		EQU		013Bh		;    7  
B2SerRR8GT		EQU		013Ch		;    8  
B2SerRR9GT		EQU		013Dh		;    9  
B2SerRR10GT		EQU		013Eh		;    10  

B2SerRR11GT		EQU		013Fh		;    11  
B2SerRR12GT		EQU		0140h		;    12  
B2SerRR13GT		EQU		0141h		;    13  
B2SerRR14GT		EQU		0142h		;    14  
B2SerRR15GT		EQU		0143h		;    15  
B2SerRR16GT		EQU		0144h		;    16  
B2SerRR17GT		EQU		0145h		;    17  
B2SerRR18GT		EQU		0146h		;    18  
B2SerRR19GT		EQU		0147h		;    19  
B2SerRR20GT		EQU		0148h		;    20  

B2SerRR21GT		EQU		0149h		;    21  
B2SerRR22GT		EQU		014Ah		;    22  
B2SerRR23GT		EQU		014Bh		;    23  
B2SerRR24GT		EQU		014Ch		;    24  

; B2TEMP_DIGIT1		EQU		014Dh		;   2 
; B2TEMP_DIGIT2		EQU		014Eh		;   2  
; B2TEMP_DIGIT3		EQU		014Fh		;   2
; B2TEMP_DIGIT4		EQU		0150h		;   2
; B2TEMP_DIGIT5		EQU		0151h		;   2

; B2TEMP_DIGIT6		EQU		0152h		;   2
; B2TEMP_DIGIT7		EQU		0153h		;   2 
; B2TEMP_DIGIT8		EQU		0154h		;   2
; B2TEMP_DIGIT9		EQU		0155h		;   2
; B2TEMP_DIGIT10		EQU		0156h		;   2
; B256		EQU		0157h		;   2
; B257		EQU		0158h		;   2
; B258		EQU		0159h		;   2
; B259		EQU		015Ah		;   2
; B260		EQU		015Bh		;   2

; B261		EQU		015Ch		;   2 
; B262		EQU		015Dh		;   2
; B263		EQU		015Eh		;   2
; B264		EQU		015Fh		;   2
; B265		EQU		0160h		;   2
; B266		EQU		0161h		;   2
; B267		EQU		0162h		;   2
; B268		EQU		0163h		;   2
; B269		EQU		0164h		;   2
; B270		EQU		0165h		;   2

; B271		EQU		0166h		;   2
; B272		EQU		0167h		;   2
; B273		EQU		0168h		;   2
; B274		EQU		0169h		;   2
; B275		EQU		016Ah		;   2
; B276		EQU		016Bh		;   2
; B277		EQU		016Ch		;   2
; B278		EQU		016Dh		;   2
; B279		EQU		016Eh		;   2
; B280		EQU		016Fh		;   2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;   (4-  ) ²  16 ϲ òв
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
StopByte  			EQU	    B'10101010' ;  ,    
										;        (B'10101010')
#DEFINE       res_lcd     PORTB,4	;   -    LCD  Nokia 5110
;    PIC16F648A      
;	#DEFINE	cs	PORTB,5	;  _CE_ (_ChipEnabled_), 2-  LCD Nokia 5110,
						;    '    ().
#DEFINE       dat_com     PORTB,6           ;
#DEFINE       sdata       PORTB,7           ;
#DEFINE       sclk        PORTA,1           ;

#DEFINE       sda         PORTB,2           ; SDA    BMP180
#DEFINE       scl         PORTB,3           ; SCL    BMP180
#DEFINE       sda_io      TRISB,2           ;  SDA 
#DEFINE       scl_io      TRISB,3           ;  SCL 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#DEFINE		Gyvl_LCD		PORTA,0	;    (Ͳ -   i2c)
#DEFINE		KnPidsv			PORTA,3	;  "ϳ "
#DEFINE		MinusPidsv		PORTA,4	;  "-3 "()    
									; (   2)
#DEFINE		KnVysotaTysk		PORTA,2	;  "(=0) - "
#DEFINE		KnRadTemperatura	PORTA,6	;  "г  -   "
#DEFINE		KnRegymZvuku		PORTA,5	;  " "
#DEFINE		ImpHV			PORTA,7	;        -
									; (   -21  260(?))
#DEFINE		FotoDatchyk		PORTB,1	;      /  
#DEFINE		LedZvuk			PORTB,5	;     -   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;initialize eeprom locations     
	ORG	0x2100
;--------------------------------------------------------------------------------
;	SonjachnoVerhTbl			;"   " "
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'11111111',B'00000001',B'00100001',B'10100101',B'10101001',B'00000001',B'01110001',B'10001001',B'00000101',B'00000101',B'00000101',B'10001001',B'01110001',B'000000001',B'10101001'
	DE	B'00100101',B'00100001',B'00000001',B'11111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	SonjachnoNyzTbl			;   " "
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'01111111',B'01000000',B'01010000',B'01001010',B'01000110',B'01001110',B'01000000',B'01001100',B'01000001',B'01011101',B'01000001',B'01000100',B'01001000',B'01000010',B'01000100'
	DE	B'01000001',B'01000000',B'01000000',B'01111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	DoshchytymeVerhTbl			;   ""
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'11111111',B'00000001',B'00000101',B'00101001',B'00110001',B'00111001',B'00000001',B'11000001',B'11100001',B'11110001',B'11110001',B'11111001',B'11111001',B'11111001',B'11110001'
	DE	B'11100001',B'01000001',B'00000001',B'11111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	DoshchytymeNyzTbl			;   ""
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'01111111',B'01000000',B'01000000',B'01000000',B'01000000',B'01000000',B'01001100',B'01000000',B'01011001',B'01000001',B'01011011',B'01000011',B'01011001',B'01000001',B'01001101'
	DE	B'01000000',B'01000110',B'01000000',B'01111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	PogodaZaViknomVerhTbl			;   "  " 
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'11111111',B'00000001',B'00000001',B'11111101',B'00000101',B'00000101',B'00000101',B'00000101',B'00000101',B'11111101',B'01000101',B'01000101',B'01000101',B'01000101',B'01000101'
	DE	B'11111101',B'00000001',B'00000001',B'11111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	PogodaZaViknomNyzTbl			;"   "  "
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'01111111',B'01000000',B'01000000',B'01011111',B'01010000',B'01010000',B'01010000',B'01010000',B'01010000',B'01011111',B'01010000',B'01010000',B'01010000',B'01010000',B'01010000'
	DE	B'01011111',B'01000000',B'01000000',B'01111111',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	ZnRadVerhTbl			;     -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'11000000',B'00001000',B'11110100',B'01100010',B'00000000',B'11000000',B'11100001',B'11100001',B'11100001',B'11000000',B'00000000',B'01100010',B'11110100'
	DE	B'00001000',B'11000000',B'10101010'
;--------------------------------------------------------------------------------
;	ZnRadNyzTbl				;     -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'00000001',B'00001000',B'00010000',B'00100000',B'00000000',B'00010001',B'01011011',B'01011011',B'01011011',B'00010001',B'00000000',B'00100000',B'00010000'
	DE	B'00001000',B'00000001',B'10101010'
;--------------------------------------------------------------------------------
;	ZvImpVerhTbl			;   " " -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'00000000',B'00111100',B'00100100',B'00111100',B'01000010',B'11111111',B'00000000',B'00011000',B'01000010',B'00111100',B'10000001',B'01000010',B'00111100'
	DE	B'00000000',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	ZvImpNyzTbl				;   " " -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'00000000',B'01000000',B'01000110',B'01111110',B'01000110',B'01000000',B'01000110',B'01111110',B'01000110',B'01000000',B'01000000',B'01000110',B'01111110'
	DE	B'01000110',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	BezZvVerhTbl			;   " " -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'00000000',B'00000000',B'00000000',B'00001000',B'11010000',B'01100000',B'11000000',B'10100000',B'11110000',B'00100000',B'00010000',B'00001000',B'00000000'
	DE	B'00000000',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;	BezZvNyzTbl				;   " " -  
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DE	B'00000000',B'00000000',B'00000000',B'00010000',B'00001011',B'00000110',B'00000011',B'00000110',B'00001111',B'00000100',B'00001000',B'00010000',B'00000000'
	DE	B'00000000',B'00000000',B'10101010'
;--------------------------------------------------------------------------------
;  EEPROM        
;--------------------------------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   ²Ͳ (RESET)
	ORG	0
	GOTO	Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Pererva	ORG	4
	BCF   ImpHV   ;        
;-----------------------------------------------------------------------
; W,STATUS,SPBSTOR_POVERN 
;-----------------------------------------------------------------------
	MOVWF	SPBW_TMP
	SWAPF	SPBW_TMP,F
	SWAPF	STATUS,W
	MOVWF	SPBSTATUS_TMP
	SWAPF	SPBSTOR_POVERN,W
	MOVWF	SPBSTOR_POVERN_TMP
;-----------------------------------------------------------------------
	BTFSS	INTCON,INTF	;    RB0/INT (  )
	GOTO	PerervaKin
	LCALL	ZbilshLichGeigera	;       -21
PerervaKin
	BCF	INTCON,INTF	;clear the RB0/INT flag
;-----------------------------------------------------------------------
; W,STATUS,SPBSTOR_POVERN
;-----------------------------------------------------------------------
	SWAPF	SPBSTOR_POVERN_TMP,W
	MOVWF	SPBSTOR_POVERN
	SWAPF	SPBSTATUS_TMP,W
	MOVWF	STATUS
	SWAPF	SPBW_TMP,W	
;-----------------------------------------------------------------------
	RETFIE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
Start
	         movlw       b'00000010'       ;     A     
             movwf       PORTA             ;
              movlw       b'00010000'       ;     B     
              movwf       PORTB             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00001111'       ;  \  B      
              movwf       TRISB             ;RB0,RB1,   RB2,RB3  -  ,   
 	MOVLW		B'01101100'			;  \  A   
	MOVWF		TRISA				;RA0,RA1,RA4,RA7 - ,  -                       

	MOVLW	B'10111111'	; 6-  0- ,     RB0(INT)   ,
						;    .
	MOVWF	OPTION_REG		;bit 2-0 (for WDT)
							; 000 - 1:1
							; 001 - 1:2 
							; 010 - 1:4
							; 011 - 1:8
							; 100 - 1:16
							; 101 - 1:32   !!!   
							; 110 - 1:64
							; 111 - 1:128      !!!
 
	MOVLW	B'10010000'		; 7-  -   
							; 4-  -     (   -21)
	MOVWF	INTCON 
;-----------------------------------------------------------
	BCF	INTCON,INTE		;      INT	
;-----------------------------------------------------------
	LCALL	StartoveObnulennja	;      
	CLRF	SPBSTOR_POVERN	;         '
											;       ,  .
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	     ( ²Ͳ )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	(   ,
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  "+"   PORTB,1 (pin7) ) 
	BTFSS	FotoDatchyk
	GOTO	DysplayVymkneno
	BSF	Gyvl_LCD	;;    ;;                         
              Lcall        init_lcd          ;   
              Lcall        clear_lcd         ;   

	BSF		SPBREG_IND,0	;   ² 
DysplayVymkneno                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              movlw       b'11101110'       ; (BMP180)
              movwf       slave_adr
              call        paus              ;   5,3  
											;   0-    0- 
              movlw       .22               ;    (22 )  2-  
              movwf       tmp_i2c           ;
              movlw       0xAA              ;      
              movwf       adr_i2c           ;
              bsf         flag,3            ;     
              call        read_i2c          ;    I2C
											;   0-    0-  1- 
;------------------------------------------------------------------------
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;     ˲ ί  (5 )
bmp_1
	CLRF	SPBSTOR_POVERN	; ??????????
 ;------------------
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        rd_temp		;       BMP180   I2C
								;   1-    0- 
	LCALL	ZapysTCelsDoRegistriv	;      T_HH...T_LL
  ;------------------
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        rd_pres		;      BMP180   I2C
								;   1-    0- 
;-----------------

;-----------------------------------------------------------
;	BSF	INTCON,INTE		;  ²    INT			BAD
;-----------------------------------------------------------


	LCALL	ZapysTyskDoRegistriv	;      P_HH...P_LL
               call        rash_T_P          ;      
VyvidNygnjojiStroky           
	LCALL	ZapysTEMP_binHH_LL	;     T_HH...LL    bin_HH...LL            
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        bin2dec           ;      
	LCALL	PokazPictogramVerhnStroky	;    
;;;;;;;;;;; ²   в Ĳֲ ;;;;;;;;;;;;;;;;
             call        vivod_temp        ;    LCD
	LCALL	ZapysTYSK_binHH_LL	;     P_HH...LL    bin_HH...LL            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   bin2dec  bin_HH..._LL  !!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	      ,
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	   
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        ust_cur_3         ;   2-  LCD 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	² ²  ""
 	BTFSS	SPBREG_IND,2		 ;2 - 0/1 -  ""  / ² 
	GOTO	Tysk
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	²  ""
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;   ,   "",     100 -   .
	LCALL	Zapys_binA_100B	; bin_HH..._LL--->REGA3...0, 100--->REGB3...0
;      ',   .
	;(   (bin_HH..._LL)  REGA3...0   100  REGB3...0,  ,     
;   "divide"   REGA3...0(_HH..._LL) - ,    , REGB3...0(_HH..._LL) - )
	CALL	divide            ; P/100	;
;    RA3...0      
	;      bin_HH..._LL
	LCALL	Zapys_Abin	; REGA3...0--->bin_HH..._LL

	BTFSS	KONTR_REG,3		; 3 - 0/1 -   /  ² 
		;        ""(KONTR_REG,3=1)
	GOTO	BezZapysuTyskuVidliku
; 	(--	; KONTR_REG,3 - 0/1 -   /  ² ,  ,)
;	(--	;    ²  "",  ( bit=1), 
;	      
	LCALL	Zapys_binVidlVys	; bin_HH..._LL--->VidlVys_HH..._LL
	; (         )
	BCF		KONTR_REG,6	; 6 - 0/1 -	      /   ("+"  "-")
						;        
	LCALL	ObnulennjaDigits7_10		;   7...10,   1-,    0-
	GOTO	VyvidVysoty	;   6-  KONTR_REG  vivod_p           ;   ()  LCD
					;    "h= 0000"
BezZapysuTyskuVidliku
;;;;;;;;;;;;;;      вֲ  ;;;;;;;;;;;;;;;;;;;;;;;;
; h = (Pp - Pv)(hPa) * 8,43 = delta_P * 8,43 = delta_P * 8 + delta_P * 0,43 =        ;
;   = delta_P * 8 + delta_P *(110 / 256),  0,43 = 110,08 / 256 () ;
;  , h = delta_P*(8*256 +110) / 256 = delta_P*2158 / 256					 ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; h() = delta_P() * 2158 / 256 ;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 1.    = 800 (   180 - 300...1100)   ;
; 2.   (delta_P*2158) = 800 * 2158 = 1 726 400 (),                ;
; 	      4-  FF FF FF FF = 16 777 215 (),  ;
; 	  4-   .                                   ;
; 3.    256     :                           ;
; _LH--->_LL, _HL--->_LH, _HH--->_HL,      _HH .                    ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;     ,        (VidlVys_...  bin_...)
	LCALL	Zapys_VidlAB_binAB	; 
	BANK0
	BTFSS		KONTR_REG,6	; 6 - 0/1 -	      /   ("+"  "-")	
						;        
	GOTO	VyvidVysoty	;  h = 0,     (Zapys_VidlAB_binAB)   DIGI7...10,   .
	BANK1
	CALL	subtract;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow
 ;    RA3...0          (h=0)
	LCALL	REGB_2158	;   "2158 = 00 00 08 6E"   REGB3...0 (REGB3,2 = "0", REGB1 = 0x08, REGB0 = 0x6E )
	CALL	multiply	;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow
;    RA3...0   delta_P() * 2158
	LCALL	ZsuvREGA_bin	;    REGA3--->bin_HL, REGA2--->bin_LH,REGA1--->bin_LL, '0'--->bin_HH 
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        bin2dec           ;      
	GOTO	VyvidVysoty	;  h = 0,       DIGI7...10,   .
Tysk
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        bin2dec           ;      
; !!! ϳ   "bin2dec"    bin_HH..._LL  ()
VyvidVysoty
            call        vivod_p           ;   ()  LCD
;;;;;;;;;;  '  ,           . . 
;;;;;;;;;;       133  133,3223684,
;;;;;;;;;;     . .  (133 / 133,3223684 = 0,99758281540717).
;;;;;;;;;;    700...800  . .      :
;;;;;;;;;; (700...800) * (1 - 0,99758281540717) = (700...800) * 0,0024179618459283 = 
;;;;;;;;;;        = () 1,69 ...1,93  . .
;;;;;;;;;; ,      2  . ., 
;;;;;;;;;;     . .   
	LCALL	ZapysTysk_MM_binHH_LL_TaUtochnen	;     P_M...L    bin_LH...LL 
												;   (  ( ..) = (-2)( ..))           
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL        bin2dec           ;      
	LCALL	ust_cur_1         ;   1-  LCD 
              call        viv_p_mm          ;   ( ..)  LCD 
	LCALL	VyznPotRezT		;     ( . . - 700)
							; .  - DIGIT9, DIGIT10, .  - PotRezVymT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	   ί    . .
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	BTFSC	KONTR_REG,0		;          RezT1,
	GOTO	NePershVyvidPisljaVvimknennja	;              "  "
	BSF		KONTR_REG,0		;       
	MOVF_F	PotRezVymT,RezT1		;
NePershVyvidPisljaVvimknennja	
	LCALL	InformPokaz		; .    ,      
;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  "SLEEP",
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	   1  (5 ),   2,308.
Spaty
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  "ϲ²"   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	"",  WDT = 2,304.
						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
						;    ;
						;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;; ²ߪ,     :
; RA2 -  / 
; RA3 - ² ϲ²
; RA5 -    ( )
; RA6 -   / в Ĳֲ
	MOVLW	B'01101100'		; 
	ANDWF	PORTA,W			; Ĳߪ Ҳ  
	SUBLW	B'01101100'		;   - 1
	BTFSC	STATUS,Z		; Z=0 -   
	GOTO	ObrobkaNatKnKIN	
;-----------------------------------------------------------
	LGOTO	ObrobkaNatKn	;    
							; (           )
ObrobkaNatKnKIN	; ʲ   
;-----------------------------------------------------------

;-----------------------------------------------------------
	LGOTO	SkynutyKontrBity	;   
;	BCF		SPBKONTR_REGRR,7	;      .
;	BCF		SPBKONTR_REGRR,6	;      .
;	BCF		KONTR_REG,3		;     䳿   "(=0) - "
;	BCF		KONTR_REG,7		;     䳿   "ϳ "
SkynutyKontrBityKIN
;-----------------------------------------------------------
;;;;;;;;;;;;;;   /   (   RA0(pin17) - Gyvl_LCD)
;;;;;;;;;;; ²,    (RB1(pin7) - +) -   
;;;;;;;;;;;   WDT (2,304.)
;;;;;;;;;;; ,        1 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSS	FotoDatchyk			;
	GOTO	NeVmykatyDysplay	;

	BTFSC	SPBREG_IND,0		;   ,      ,
	GOTO	NeInicijuvatyDysplay	;        SPBREG_IND,0

	BSF	Gyvl_LCD	;;    ;;                         
;;      "sendispdat",
;;            в   
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
           Lcall        init_lcd          ;   
      Lcall        clear_lcd         ;   
	BSF		SPBREG_IND,0		;    ,   ²
	BTFSS	SPBREG_IND,1	;
	GOTO	ZalyshPozytyv	;
	MOVLW	B'00001101'		;  
	LCALL	sendispcom		;    
ZalyshPozytyv
	GOTO	bmp_1             ;   bmp_1
NeVmykatyDysplay	;   
NeInicijuvatyDysplay
;---------------------------------------------------------
	LCALL	HV	;  ί   ˲
;---------------------------------------------------------
	BSF	INTCON,INTE		;  ²    INT		
;---------------------------------------------------------

			SLEEP					;******** ղ   "" *******************
; ,  ²   ֲ̲   :
; - ʲ в WDT ;
; -   ² ˲.

;-----------------------------------------------------------
	BCF	INTCON,INTE		;      INT			
;-----------------------------------------------------------


	BTFSC	SPBREG_IND,4	; ,        .
	GOTO	NeZminPozyt__Negat	;
	BTFSS	SPBREG_IND,1	; ,      
	GOTO	NeZminPozyt__Negat	;
	MOVLW	B'00001101'		;  
	LCALL	sendispcom		;    
	BSF		SPBREG_IND,4	;  ,       ²
NeZminPozyt__Negat

	BTFSS	SPBKONTR_REGRR,5		;        
	GOTO	NeVidprRR255		;  (50/)    (255/)
	BCF		SPBKONTR_REGRR,5		;      ...
	GOTO	bmp_1             	;  
NeVidprRR255
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	 ϲ² ,   "ϳ "   
	BTFSC	KnPidsv			; PORTA,3	;  "ϳ "
	BSF		MinusPidsv		;	PORTA,4	;  "+3 "    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
;********************************************************************************************************
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  1  (5 )		HVYLYNA-----HVYLYNA-----HVYLYNA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSS	SPBFixatorIMP,1		; Ѳ ʲ ,     -21  
							;    WDT     ,          
							;  ""   SLEEP     .
							; ,          ,
							;     WDT       
							;        -.
	GOTO	ZbilxshKilPerWDT
	CLRF	SPBFixatorIMP	;	  2-   
	GOTO	NeZminKilPerWDT
ZbilxshKilPerWDT
	INCF	KilPerWDT,F		;    WDT,  ,    5 
							; 0,028  128 (.  )  130 = 299,52 = . 5.
NeZminKilPerWDT
;------------------------------------------------------------------------------------------------
	LGOTO	PereryvchZv		;       2-   
;       2-   
PereryvchZvKIN
;------------------------------------------------------------------------------------------------
							; 0,028  128 (.  )  130 = 299,52 = . 5.
;;	MOVLW	D'20'	;    (в 1 a) !!!    . 
					;    ,   ²  D'26' !!!
	MOVLW	D'100'	;    (в 5 )

;;	MOVLW	D'51'	;   0.028 x 32() x 2() = 1.792
;;	MOVLW	D'2'	;   0.028 x 32() x 2() = 1.792
;;	MOVLW	D'10'	;   0.028 x 32() x 5() = 30
;;	MOVLW	D'1'	;   0.028 x 32() x 1() = 0.896
;------------------------------------------------------------------------------------------------
;PerevZakinchIntVym	;,      (5   -21
; -      - GOTO	Spaty	
; -      "" - GOTO	Spaty	
; -  ,   "" - goto	bmp_1	; ު ֲ  ů
;   "",       !!!
;   W    WDT    (5  - 100 ) 

	SUBWF	KilPerWDT,W
	BTFSC	STATUS,Z		; Z = 0, ,    .
	GOTO	IntVymZakincheno	;
	BTFSS	SPBREG_IND,0		; 1 -  ²
	GOTO	Spaty				; 0 -  
	BTFSS	SPBREG_IND,2	; 2 - 0/1 -  ""  / ²
	GOTO	Spaty
	goto        bmp_1             ; ު ֲ  ů
IntVymZakincheno	;

;-----------------------------------------------------------
;	BCF	INTCON,INTE		;      INT		BAD		
;-----------------------------------------------------------

;------------------------------------------------------------------------------------------------
	BCF		LedZvuk			;     ,   
	CLRF	KilPerWDT		;
;-----------------------------------------------------------
	BCF	INTCON,INTE		;      INT			
;-----------------------------------------------------------
	LCALL	VyznSerRR				; ϲ  в Ĳֲ ϲ ̲ (5 )
; ²  ϲ ²:
;  ʲʲ ̲в,  ² B2KilxkVymRR = 0,  ò  ̲ B2NomerRegZapRR = 0
;
;  SPBLichylxnykIMP ( ),      B2VymRR1...12
;   B2SerRR (    )
;     (, .  25512 = 3060)    B2KilxkVymRR (..=12).
;       0...11,0...11,0...,
;     ,        .
;-------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;     (   / Ĳֲ)
	LGOTO	RegymPokazu		;      '
RegymPokazuKIN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  1 		GODYNA-----GODYNA-----GODYNA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	INCF	GodynaZhvylyn,F	;     5- 
;;	MOVLW	D'60'	; 1 a  60 = 60  = 1  ( 2,304.  26  60 = 3594,24,
					; ,    5,76.,    138,24.,  Ҫ !!!

	MOVLW	D'12'	; 5   12 = 60  = 1 

;;	MOVLW	D'2'	;   ;;
;;	MOVLW	D'1'	;   ;;
	SUBWF	GodynaZhvylyn,W	;
	BTFSS	STATUS,Z			;
	GOTO	BezZapysuDoMasyvu	;
	CLRF 	GodynaZhvylyn

	BCF		SPBKONTR_REGRR,0	;         "",
	BCF		SPBKONTR_REGRR,1	;    0-  1-   SPBKONTR_REGRR

	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL	ZapysDoMasRezT		;         . . - 700   
								; PotRezVymT - Ͳ  .
	LCALL	ZapysDoMasRezRR		;        в Ĳֲ   
								; B2SerRR - Ͳ   (2 - BANK2).
BezZapysuDoMasyvu	;
;    (SPBREG_IND,0 = 0),   Ͳ  в . 
;    
	BTFSS	SPBREG_IND,0		; 1 -  ²
	GOTO	Spaty				; 0 -  
       goto        bmp_1             ;   bmp_1
;######################################################################################################
;		ʲ   			#######################################################                                                          
;######################################################################################################

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		ϲ ί в ί 'Ҳ                                              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;            PIC16F628A  , PIC16F648A -   (  )                  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;      
rash_T_P      bsf         STATUS,RP0        ;  2- 

              clrf        REGA3             ;   UT  REGA
              clrf        REGA2
              movf        T_LH,W
              movwf       REGA1
              movf        T_LL,W
              movwf       REGA0

              clrf        REGB3             ;   AC6  REGB
              clrf        REGB2
              movf        AC6_LH,W
              movwf       REGB1
              movf        AC6_LL,W
              movwf       REGB0

              call        subtract          ; UT-AC6

              clrf        REGB3             ;   AC5  REGB
              clrf        REGB2
              movf        AC5_LH,W
              movwf       REGB1
              movf        AC5_LL,W
              movwf       REGB0

              call        multiply          ; (UT-AC6)*AC5

              movlw       .15               ; [(UT-AC6)*AC5]/2^15 = X1
              movwf       tmp
tdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_a1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       MD_LH,7           ;   MD  REGB
              goto        tzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        tzag_a2
tzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
tzag_a2       movf        MD_LH,W
              movwf       REGB1
              movf        MD_LL,W
              movwf       REGB0

              call        add               ; X1+MD

              movf        REGA0,W           ;  (X1+MD)  REGB
              movwf       REGB0            
              movf        REGA1,W         
              movwf       REGB1
              movf        REGA2,W         
              movwf       REGB2
              movf        REGA3,W         
              movwf       REGB3  
 
              btfsc       MC_LH,7           ;   MC
              goto        tzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        tzag_b2
tzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
tzag_b2       movf        MC_LH,W
              movwf       REGA1
              movf        MC_LL,W
              movwf       REGA0
              
              movlw       .11               ; MC * 2^11
              movwf       tmp
tumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        tumn_a1

              call        divide            ; (MC * 2^11)/(X1+MD) = X2

              movf        X1_HH,W           ;  X1  REGB
              movwf       REGB3
              movf        X1_HL,W
              movwf       REGB2
              movf        X1_LH,W
              movwf       REGB1
              movf        X1_LL,W
              movwf       REGB0

              call        add               ; X1 + X2 = B5

              movf        REGA3,W           ;    B5
              movwf       B5_HH
              movf        REGA2,W
              movwf       B5_HL
              movf        REGA1,W
              movwf       B5_LH
              movf        REGA0,W
              movwf       B5_LL

              movlw       .8                ;  8  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; B5 + 8

              movlw       .4                ; (B5 + 8)/2^4
              movwf       tmp
tdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        tdel_b1

              movf        REGA0,W           ;     T
              movwf       T_LL
              movf        REGA1,W
              movwf       T_LH
              movf        REGA2,W
              movwf       T_HL
              movf        REGA3,W
              movwf       T_HH

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rash_P        movf        B5_HH,W           ;  B5  REGA
              movwf       REGA3
              movf        B5_HL,W
              movwf       REGA2
              movf        B5_LH,W
              movwf       REGA1
              movf        B5_LL,W
              movwf       REGA0

                            
              clrf        REGB3             ;  4000  REGB
              clrf        REGB2
              movlw       0x0F
              movwf       REGB1
              movlw       0xA0
              movwf       REGB0

              call        subtract          ; B5 - 4000 = B6

              movf        REGA3,W           ;    B6  REGB
              movwf       B6_HH
              movwf       REGB3
              movf        REGA2,W
              movwf       B6_HL
              movwf       REGB2
              movf        REGA1,W
              movwf       B6_LH
              movwf       REGB1
              movf        REGA0,W
              movwf       B6_LL
              movwf       REGB0

              call        multiply          ; B6 * B6

              movlw       .12               ; (B6 * B6)/2^12
              movwf       tmp
pdel_a1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_a1

              movf        REGA3,W           ;  ((B6 * B6)/2^12)   X2
              movwf       X2_HH             ;  ,   X2   
              movf        REGA2,W
              movwf       X2_HL
              movf        REGA1,W
              movwf       X2_LH
              movf        REGA0,W
              movwf       X2_LL

              btfsc       B2_LH,7           ;   B2  REGB
              goto        pzag_a1
              clrf        REGB3
              clrf        REGB2
              goto        pzag_a2
pzag_a1       movlw       .255
              movwf       REGB3
              movlw       .255
              movwf       REGB2
pzag_a2       movf        B2_LH,W
              movwf       REGB1
              movf        B2_LL,W
              movwf       REGB0

              call        multiply          ; B2 * [(B6 * B6)/2^12]

              movlw       .11               ; (B2 * [(B6 * B6)/2^12])/2^11
              movwf       tmp
pdel_b1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_b1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       AC2_LH,7          ;   AC2  REGA
              goto        pzag_b1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_b2
pzag_b1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_b2       movf        AC2_LH,W
              movwf       REGA1
              movf        AC2_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC2 * B6

              movlw       .11               ; (AC2 * B6)/2^11 = X2
              movwf       tmp
pdel_c1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_c1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2 = X3

              movf        REGA3,W           ;    X3
              movwf       X3_HH
              movf        REGA2,W
              movwf       X3_HL
              movf        REGA1,W
              movwf       X3_LH
              movf        REGA0,W
              movwf       X3_LL

              btfsc       AC1_LH,7          ;   AC1  REGA
              goto        pzag_c1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_c2
pzag_c1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_c2       movf        AC1_LH,W
              movwf       REGA1
              movf        AC1_LL,W
              movwf       REGA0

              movlw       .2                ; AC1 * 4
              movwf       tmp
pumn_a1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_a1

              movf        X3_LL,W           ;  X3  REGB
              movwf       REGB0            
              movf        X3_LH,W         
              movwf       REGB1
              movf        X3_HL,W         
              movwf       REGB2
              movf        X3_HH,W         
              movwf       REGB3  

              call        add               ; (AC1 * 4) + X3

              bcf         STATUS,RP0
              movf        oss,W             ; ((AC1 * 4) + X3)<<oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pumn_c1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pumn_b1       bcf         STATUS,C
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
              decfsz      tmp,F
              goto        pumn_b1

pumn_c1       movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; [((AC1 * 4) + X3)<<oss] + 2

              movlw       .2                ; ([((AC1 * 4) + X3)<<oss] + 2)/4
              movwf       tmp
pdel_d1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_d1
 
              movf        REGA3,W           ;    B3
              movwf       B3_HH
              movf        REGA2,W
              movwf       B3_HL
              movf        REGA1,W
              movwf       B3_LH
              movf        REGA0,W
              movwf       B3_LL

              btfsc       AC3_LH,7          ;   AC3  REGA
              goto        pzag_d1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_d2
pzag_d1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_d2       movf        AC3_LH,W
              movwf       REGA1
              movf        AC3_LL,W
              movwf       REGA0

              movf        B6_LL,W           ;  B6  REGB
              movwf       REGB0            
              movf        B6_LH,W         
              movwf       REGB1
              movf        B6_HL,W         
              movwf       REGB2
              movf        B6_HH,W         
              movwf       REGB3  

              call        multiply          ; AC3 * B6

              movlw       .13               ; (AC3 * B6)/2^13 = X1
              movwf       tmp
pdel_e1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_e1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              btfsc       B1_LH,7           ;   B1  REGA
              goto        pzag_e1
              clrf        REGA3
              clrf        REGA2
              goto        pzag_e2
pzag_e1       movlw       .255
              movwf       REGA3
              movlw       .255
              movwf       REGA2
pzag_e2       movf        B1_LH,W
              movwf       REGA1
              movf        B1_LL,W
              movwf       REGA0

              movf        X2_LL,W           ;  (B6 * B6)/2^12  X2  REGB
              movwf       REGB0            
              movf        X2_LH,W         
              movwf       REGB1
              movf        X2_HL,W         
              movwf       REGB2
              movf        X2_HH,W         
              movwf       REGB3  

              call        multiply          ; B1 * ((B6 * B6)/2^12)

              movlw       .16               ; (B1 * ((B6 * B6)/2^12))/2^16 = X2
              movwf       tmp
pdel_f1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_f1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  

              call        add               ; X1 + X2

              movlw       .2                ;  2  REGB
              movwf       REGB0
              clrf        REGB1
              clrf        REGB2
              clrf        REGB3

              call        add               ; (X1 + X2) + 2

              movlw       .2                ; ((X1 + X2) + 2)/4 = X3
              movwf       tmp
pdel_g1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_g1                     
               
              clrf        REGB3             ;  32768  REGB
              clrf        REGB2
              movlw       0x80
              movwf       REGB1
              clrf        REGB0

              call        add               ; X3 + 32768 

              clrf        REGB3             ;   AC4  REGB
              clrf        REGB2
              movf        AC4_LH,W
              movwf       REGB1
              movf        AC4_LL,W
              movwf       REGB0

              call        multiply          ; AC4 * (X3 + 32768)

              movlw       .15               ; (AC4 * (X3 + 32768)/2^15) = B4
              movwf       tmp
pdel_h1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_h1

              movf        REGA3,W           ;    B4
              movwf       B4_HH
              movf        REGA2,W
              movwf       B4_HL
              movf        REGA1,W
              movwf       B4_LH
              movf        REGA0,W
              movwf       B4_LL

              movf        P_HH,W            ;  UP  REGA
              movwf       REGA3
              movf        P_HL,W
              movwf       REGA2
              movf        P_LH,W
              movwf       REGA1
              movf        P_LL,W
              movwf       REGA0

              movf        B3_LL,W           ;  B3  REGB
              movwf       REGB0            
              movf        B3_LH,W         
              movwf       REGB1
              movf        B3_HL,W         
              movwf       REGB2
              movf        B3_HH,W         
              movwf       REGB3  

              call        subtract          ; UP-B3
                
              clrf        REGB3             ;  50000  REGB
              clrf        REGB2
              movlw       0xC3
              movwf       REGB1
              movlw       0x50
              movwf       REGB0

              bcf         STATUS,RP0
              movf        oss,W             ; 50000 >> oss
              xorlw       .0
              bsf         STATUS,RP0
              btfsc       STATUS,Z
              goto        pdel_k1
              bcf         STATUS,RP0
              movf        oss,W 
              bsf         STATUS,RP0              
              movwf       tmp
pdel_j1       rlf         REGB3,W
              rrf         REGB3,F
              rrf         REGB2,F
              rrf         REGB1,F
              rrf         REGB0,F
              decfsz      tmp,F
              goto        pdel_j1

pdel_k1       call        multiply          ; (UP-B3) * (50000 >> oss)

              btfsc       REGB3,7
              goto        rash_P1

              bcf         STATUS,C          ;B7 < 0x80000000  (B7 * 2)
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
            
              movf        B4_LL,W           ;  B4  REGB
              movwf       REGB0           
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  
              
              call        divide_uns        ;  (B7 * 2)/B4
              goto        rash_P2

rash_P1       movf        B4_LL,W           ;B7 >= 0x80000000,   B4  REGB
              movwf       REGB0            
              movf        B4_LH,W         
              movwf       REGB1
              movf        B4_HL,W         
              movwf       REGB2
              movf        B4_HH,W         
              movwf       REGB3  

              call        divide_uns        ;  B7/B4

              bcf         STATUS,C          ; (B7/B4) * 2
              rlf         REGA0,F
              rlf         REGA1,F
              rlf         REGA2,F
              rlf         REGA3,F
             

rash_P2       movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              movlw       .8                ; P/2^8
              movwf       tmp
pdel_l1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_l1

              movf        REGA3,W           ;   REGA  REGB
              movwf       REGB3
              movf        REGA2,W
              movwf       REGB2
              movf        REGA1,W
              movwf       REGB1
              movf        REGA0,W
              movwf       REGB0

              call        multiply          ; (P/2^8) * (P/2^8) = X1
             
              clrf        REGB3             ;  3038  REGB
              clrf        REGB2
              movlw       0x0B
              movwf       REGB1
              movlw       0xDE
              movwf       REGB0

              call        multiply          ; X1 * 3038

              movlw       .16               ; (X1 * 3038)/2^16 = X1
              movwf       tmp
pdel_o1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_o1

              movf        REGA3,W           ;    X1
              movwf       X1_HH
              movf        REGA2,W
              movwf       X1_HL
              movf        REGA1,W
              movwf       X1_LH
              movf        REGA0,W
              movwf       X1_LL

              movlw       0xFF              ;  -7357  REGA
              movwf       REGA3           
              movlw       0xFF
              movwf       REGA2
              movlw       0xE3
              movwf       REGA1
              movlw       0x43
              movwf       REGA0
    
              movf        P_LL,W            ;  P  REGB
              movwf       REGB0           
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W         
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        multiply          ; (-7357) * P

              movlw       .16               ; ((-7357) * P)/2^16 = X2
              movwf       tmp
pdel_p1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_p1

              movf        X1_LL,W           ;  X1  REGB
              movwf       REGB0            
              movf        X1_LH,W         
              movwf       REGB1
              movf        X1_HL,W         
              movwf       REGB2
              movf        X1_HH,W         
              movwf       REGB3  
 
              call        add               ; (X1 + X2)

              clrf        REGB3             ;  3791  REGB
              clrf        REGB2
              movlw       0x0E
              movwf       REGB1
              movlw       0xCF
              movwf       REGB0

              call        add               ; (X1 + X2)+3791

              movlw       .4                ; ((X1 + X2)+3791)/2^4
              movwf       tmp
pdel_q1       rlf         REGA3,W
              rrf         REGA3,F
              rrf         REGA2,F
              rrf         REGA1,F
              rrf         REGA0,F
              decfsz      tmp,F
              goto        pdel_q1

              movf        P_LL,W            ;  P  REGB
              movwf       REGB0            
              movf        P_LH,W         
              movwf       REGB1
              movf        P_HL,W       
              movwf       REGB2
              movf        P_HH,W         
              movwf       REGB3  

              call        add               ; P + ((X1 + X2)+3791)/2^4 = P

              movf        REGA3,W           ;    P
              movwf       P_HH
              movf        REGA2,W
              movwf       P_HL
              movf        REGA1,W
              movwf       P_LH
              movf        REGA0,W
              movwf       P_LL

              clrf        REGB3             ;  133  REGB
              clrf        REGB2
              clrf        REGB1
              movlw       0x85
              movwf       REGB0

              call        divide            ; P/133    ..

              movf        REGA1,W           ;    P_M, P_L
              movwf       P_M
              movf        REGA0,W
              movwf       P_L
 
              bcf         STATUS,RP0
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;		Ͳ (²) ϲ                                                        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;---------------------------------------------------------
;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow
subtract
              call        negateb		;Negate REGB
              skpnc
	          return			;Overflow
;---------------------------------------------------------
;*** 32 BIT SIGNED ADD ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return
;---------------------------------------------------------
;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return
;---------------------------------------------------------
;*** 32 BIT SIGNED DIVIDE ***
;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

dv_un	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

divide_uns   clrf	MTEMP		;Reset sign flag
	         movf	REGB0,w		;Trap division by zero
          	 iorwf	REGB1,w
	         iorwf	REGB2,w
   	         iorwf	REGB3,w
	         sublw	0
	         skpnc
	         return			;Overflow
             goto   dv_un
;---------------------------------------------------------
;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return
;---------------------------------------------------------
;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return
;---------------------------------------------------------
;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return
;---------------------------------------------------------
;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive
;---------------------------------------------------------
;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round
negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return
;---------------------------------------------------------
;Check sign of REGB and convert negative to positive
;Used by multiply, divide
absb	rlf	REGB3,w
	skpc
	return			;Positive
;---------------------------------------------------------
;Negate REGB
;Used by absb, subtract, multiply, divide
negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return
;---------------------------------------------------------
;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return
;---------------------------------------------------------
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        Ѳ           ----------------------------
;    LCD 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        Ѳ           ----------------------------
vivod_temp		; 77777777777777777
	BANK0
	BTFSS	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	JakBulo	

	CLRF	bin_HH
	CLRF	bin_HL
	CLRF	bin_LH
	BANK2
	MOVFW	B2SerRR	;       ,  
	BANK0
	MOVWF	bin_LL
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
	LCALL	bin2dec
JakBulo
	LCALL        ust_cur_5         ;   5-  LCD 

      movlw       D'143'              ;    X0=120
          movwf       x_adr
          call        sendispcom	;	
 
	BTFSC	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	PozycijaRR
	GOTO	PozycijaTGradC 
PozycijaRR
;---------------------------------------------------------
; ² Բ ̲  в Ĳֲ  
;---------------------------------------------------------
;=============================================================================================
	movlw       ' '		;        
	call        viv_symb          ;     

	BANK2
	MOVFW	B2SerRR			;        в Ĳֲ
	BANK0
	MOVWF	VidlikGraf		;        в Ĳֲ
	BANK2
	MOVLW	B2SerRR24GT		;    24  
	MOVWF	FSR
	MOVF_F	FSR,SPBPotFSR		; Ѳ ʲ  -   FSR 24-,  
	BANK1
	LOADF	Y_GRAF,0x44		;    Բ - 5
	BANK0
	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3
	LCALL	Grafik		;       VidlikGraf
;           (1(y_adr=040)  3(y_adr=042))
;   	STATUS,IRP
; IRP = 0 ,   ֲ Ӫ  ò  0  1
; IRP = 1 ,   ֲ Ӫ  ò  2  3
; ղͲ Ͳ:
; Y_GRAF -  y_adr    (1(y_adr=040)  3(y_adr=042))
; SPBPotFSR - FSR 24- ,         в Ĳֲ
; VidlikGraf -  ,      =  PotRezVymT ( )  B2SerRR ( в Ĳֲ)
; (     VerhByteGraf, NygnByteGraf)
;=============================================================================================
	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
;=============================================================================================
;------------------------------------------------------------------
;        
;------------------------------------------------------------------
	LCALL        ust_cur_5         ;   5-  LCD 
      movlw       D'173'              ;    X0=173
          movwf       x_adr
          call        sendispcom	;	
;---------------------------------------------------------
PozycijaTGradC
	BTFSC	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	PropuskZn
            btfss       flag,7            ;  
              goto        ZnPLUS
              movlw       '-'
              call        viv_symb          ;     
              goto        PropuskZn 
ZnPLUS
        movlw       '+'
              call        viv_symb          ;     
PropuskZn
        movf        DIGIT8,W
              xorlw       .0
              btfsc       STATUS,Z
              goto        DrugaCyfra

              movf        DIGIT8,W          ; 
              addlw       .48               ;
              call        viv_symb          ;     
DrugaCyfra              
	BTFSS	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	VyvidDrCyfry	;

	MOVFW	DIGIT9			;     
	XORLW	D'0'			;    ,
	BTFSS	STATUS,Z		;    
	GOTO	VyvidDrCyfry	; 
	MOVLW	' '				; .
	CALL	viv_symb		;      
	GOTO	PropuskKomy		;
VyvidDrCyfry
        movf        DIGIT9,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     
	BTFSC	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	PropuskKomy
              movlw       '.'
              call        viv_symb          ;     
PropuskKomy
              movf        DIGIT10,W         ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movlw       0xF8
              call        viv_symb          ;     
 	BTFSC	SPBREG_IND,3	; "0" -  , "1" -   
	GOTO	vivod_tempKIN

              movlw       'O'
              call        viv_symb          ;     

              movlw       'C'
              call        viv_symb          ;     
vivod_tempKIN
	BANK0
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            -----------
;   ()  LCD 
vivod_p
      movlw       D'131'              ;    X0=173
          movwf       x_adr
          call        sendispcom	;	
	BTFSS	SPBREG_IND,2		 ;2 - 0/1 -  ""  / ²
	GOTO	PershaCyfraTysku
	movlw  'D'					;	   "h"      ()
            call        viv_symb          ;     
   movlw  'B'					;	'B'   "="
           call        viv_symb          ;     
;;; 6 - 0/1 -	      /   ("+" 
	BTFSC	KONTR_REG,6	; 6 - 0/1 -	      /   ("+" 
	GOTO	PlusMin
              movlw       ' ' ;  
              call        viv_symb          ;     
	GOTO	CYFRA7		;
PlusMin
	BTFSS	KONTR_REG,4		; 1 - "+", 0 - "-"
	GOTO	ZnMinus			;
       movlw       '+'
            call        viv_symb          ;     
	GOTO	CYFRA7		;
ZnMinus
            movlw       '-'
            call        viv_symb          ;     
	GOTO	CYFRA7	
PershaCyfraTysku
		       movf        DIGIT5,W
             xorlw       .0
            btfsc       STATUS,Z
           goto        vivd_p1

             movf        DIGIT5,W          ; 
            addlw       .48               ;
           call        viv_symb          ;     
vivd_p1
      movf        DIGIT6,W          ;  
            addlw       .48               ;
           call        viv_symb          ;     
CYFRA7
              movf        DIGIT7,W          ;  
              addlw       .48               ;
             call        viv_symb          ;     


             movf        DIGIT8,W          ;  
            addlw       .48               ;
           call        viv_symb          ;     
              movf        DIGIT9,W          ; 
              addlw       .48               ;
              call        viv_symb          ;     

			movf        DIGIT10,W         ;  
			addlw       .48               ;
			call        viv_symb          ;     
  
	BTFSC	SPBREG_IND,2		 ;2 - 0/1 -  ""  / ²
	GOTO	Metry
             movlw       'E'				; 	   ""
              call        viv_symb          ;     
 
              movlw       'F'				; 	   ""
              call        viv_symb          ;     
	GOTO	Paskali
Metry
             movlw       'Q'
              call        viv_symb          ;     
	GOTO	VSE
Paskali
 ;;;     ,      ,
 ;	      ""   ,   "",  , 
 ;	    1000
		       movf        DIGIT5,W
             xorlw       .0
	BTFSS	STATUS,Z
	GOTO	VSE
             movlw       ' ' ;  
            call        viv_symb          ;     
VSE
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;          .      --------------
;   ( . .)  LCD 
viv_p_mm
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
		movlw       D'173'              ;    X0 = 173;;;;;;;;;;;;;;111111111
		movwf       x_adr
	CALL        sendispcom
      movf        DIGIT8,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     
 
              movf        DIGIT9,W          ;  
              addlw       .48               ;
              call        viv_symb          ;     

              movf        DIGIT10,W         ; 
              addlw       .48               ;
              call        viv_symb          ;     

              movlw       'P'				;;;;    ""  . 
              call        viv_symb          ;     
              return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; /   I2C
write_i2c
;-------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
;--------------------------
     bsf         flag,4            ;  
              goto        i2c_1             ;   i2c_1
read_i2c	;   0-    0-  1- 
;-------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       
;-------------------------
      bcf         flag,4            ;  ( )
              bcf         flag,5            ;   
i2c_1         bcf         flag,6            ;   I2C
              call        starti2c          ;  ""  I2C
            
              bcf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              movf        adr_i2c,W         ;  I2C
              call        peredi2c          ;   
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c
          
              btfss       flag,3            ;     
              goto        i2c_3
              bcf         flag,3
              movlw       AC1_LH
              goto        i2c_4  
i2c_3         movlw       data_i2c       
i2c_4         movwf       FSR
              decf        FSR,F

              btfss       flag,4            ;  / I2C
              goto        rd_i2c            ;   rd_i2c ()

i2c_2         incf        FSR,F
              movf        INDF,W            ;   
              call        peredi2c          ;   I2C
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

              decfsz      tmp_i2c,F
              goto        i2c_2
              call        stopi2c 
;.....................................................................................................................................
	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	
	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rd_i2c 
       call        starti2c          ;  ( )
              bsf         slave_adr,0       ;  
              movf        slave_adr,W       ;  
              call        peredi2c          ; 
              btfsc       flag,6            ;  
              goto        err_i2c           ;:   err_i2c

rd_i2c_2      decfsz      tmp_i2c,F
              goto        rd_i2c_1
              bsf         flag,5
rd_i2c_1      incf        FSR,F
              call        priemi2c          ; 
           
              movwf       INDF
              movlw       .0
              xorwf       tmp_i2c,F
              btfss       STATUS,Z
              goto        rd_i2c_2
              call        stopi2c           ; 
              return

err_i2c       call        stopi2c           ;  ""  I2C 
              return                        ;        I2C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

starti2c      call        scl_1              ;  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              return                         ;  

stopi2c       call        sda_0              ;  0  sda
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              call        scl_1              ;  scl
stpi2c_1      call        pausi2c            ; I2C (5 )
											;   0-    0- 
              btfss       scl                ;
              goto        stpi2c_1           ;
              call        sda_1              ;  sda
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              return                         ;  

sda_1         bsf         STATUS,RP0         ;  sda  
              bsf         sda_io             ;        
              bcf         STATUS,RP0         ;
              return                         ;  

sda_0         bcf         sda                ;  sda  
              bsf         STATUS,RP0         ;
              bcf         sda_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  

scl_1         bsf         STATUS,RP0         ;  scl  
              bsf         scl_io             ;        
              bcf         STATUS,RP0         ;
              return                        ;  

scl_0         bcf         scl                ;  scl  
              bsf         STATUS,RP0         ;
              bcf         scl_io             ;
              bcf         STATUS,RP0         ;
              return                         ;  


peredi2c      movwf       perem              ;    i2c
              movlw       .8                 ;
              movwf       scetbit            ;
prd_i2c_1     btfsc       perem,7            ;
              call        sda_1              ;  sda
              btfss       perem,7            ;
              call        sda_0              ;  0  sda
              call        scl_1              ;  scl
prd_i2c_2     call        pausi2c            ; I2C (5 )
											;   0-    0- 
              btfss       scl                ;
              goto        prd_i2c_2          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              rlf         perem,F            ;
              decfsz      scetbit,F          ;
              goto        prd_i2c_1          ;
            
              call        sda_1              ;  sda
              call        scl_1              ;  scl
prd_i2c_3     call        pausi2c            ; I2C (5 )
											;   0-    0- 
              btfss       scl                ;
              goto        prd_i2c_3          ;

              movlw       .20                ;  100 
              movwf       scetbit            ;
prd_i2c_4     btfss       sda                ;	
              goto        prd_i2c_5          ;
              decfsz      scetbit,F          ; 
              goto        prd_i2c_4          ;
              bsf         flag,6             ; ,    
prd_i2c_5     call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              return                         ;  


priemi2c      movlw       .8                 ;    i2c
              movwf       scetbit            ;
              call        sda_1              ;  sda
prm_i2c_1     rlf         perem,F            ;
              call        scl_1              ;  scl
prm_i2c_2     call        pausi2c            ; I2C (5 )
											;   0-    0- 
              btfss       scl                ;
              goto        prm_i2c_2          ;
              btfsc       sda                ;
              bsf         perem,0            ;
              btfss       sda                ;
              bcf         perem,0            ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              decfsz      scetbit,F          ;
              goto        prm_i2c_1          ;
 
              btfss       flag,5             ;
              call        sda_0              ;  0  sda

              call        scl_1              ;  scl
prm_i2c_3     call        pausi2c            ; I2C (5 )
											;   0-    0- 
              btfss       scl                ;
              goto        prm_i2c_3          ;
              call        scl_0              ;  0  scl
              call        pausi2c            ; I2C (5 )
											;   0-    0- 
              movf        perem,W            ;
              return                         ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             

pausi2c       nop                            ;  I2C (5 )
              return                         ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sendispcom
	movwf      perem              ;  /  
              bcf        dat_com
              goto       povt1
sendispdat    movwf      perem
              bsf        dat_com
povt1
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BCF		SPBSTOR_POVERN,0		; ʲ,    0- , 0-    "0", 
								;       ,   ,
								;       

         movlw      .8
              movwf      scetbit
povt2         bcf        sclk
              btfsc      perem,7
              bsf        sdata
              btfss      perem,7
              bcf        sdata
              bsf        sclk                                   
              rlf        perem,F
              decfsz     scetbit,F             
              goto       povt2
 	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
              return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
viv_symb      movwf       nomer             ;    
              sublw       .47               ;
              btfss       STATUS,C          ;
              goto        viv_symb_1        ;   47:    viv_symb_1
              movlw       .32               ;  nomer      (ASCII  32)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s1            ; :   viv_s1
              movlw       .0                ;     (ASCII  32)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s1        movlw       .43               ;  nomer     '+' (ASCII  43)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s2            ; :   viv_s1
              movlw       .1                ;    '+' (ASCII  43)
              movwf       nomer             ;  .  
              goto        viv_tab4           

viv_s2        movlw       .45               ;  nomer     '-' (ASCII  45)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s3            ; :   viv_s1
              movlw       .2                ;    '-' (ASCII  45)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s3        movlw       .46               ;  nomer     '.' (ASCII  46)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              return                        ; :   
              movlw       .3                ;    '.' (ASCII  46)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_symb_1    movf        nomer,W
              sublw       .57
              btfss       STATUS,C
              goto        viv_symb_2        ;   57:    viv_symb_2
              movlw       .48               ;   47   58:    tab_symb_1
              subwf       nomer,F           ;  48  ASCII  , 
              movlw       .1                ;  
              movwf       tmp_tab           ;   (1)   tmp_tab
          goto        symb_lcd

viv_symb_2    movf        nomer,W
              sublw       .64
              btfsc       STATUS,C
              return                        ;   57   65:   

              movf        nomer,W
              sublw       .78
              btfss       STATUS,C
              goto        viv_symb_3        ;   78:    viv_symb_3
              movlw       .65               ;   64   79:    tab_symb_2
              subwf       nomer,F           ;  65  ASCII  ,  
              movlw       .2                ;  
              movwf       tmp_tab           ;   (2)   tmp_tab

              goto        symb_lcd

viv_symb_3    movf        nomer,W
              sublw       .90
              btfss       STATUS,C
              goto        viv_symb_4        ;   90:    viv_symb_4
              movlw       .79               ;   78   91:    tab_symb_3
              subwf       nomer,F           ;  79  ASCII  ,  
              movlw       .3                ;  
              movwf       tmp_tab           ;   (3)   tmp_tab
              goto        symb_lcd

viv_symb_4    movlw       .176              ;  nomer     176
              xorwf       nomer,W           ;176 - ascii    , 
              btfss       STATUS,Z
              return                        ;  :   
              movlw       .4                ;   176,   , 
              movwf       nomer             ;  .  
viv_tab4      movlw       .4
              movwf       tmp_tab           ;   (4)   tmp_tab

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
symb_lcd
      movlw      .17                 ;     18
              movwf      temp
              movf       nomer,W
symb_1        addwf      nomer,F
              decfsz     temp,F
              goto       symb_1
              bcf        flag,0
     
symb_2        movlw      .9 
              movwf      temp               ;    9  

symb_3        movlw       .1                ;    
              xorwf       tmp_tab,W         ;   
              btfss       STATUS,Z
              goto        symb_m1
              call        tab_symb_1
              goto        symb_4
symb_m1       movlw       .2
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m2
              call        tab_symb_2
              goto        symb_4   
symb_m2       movlw       .3
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m3
              call        tab_symb_3
              goto        symb_4  
symb_m3       call        tab_symb_4

symb_4        call       sendispdat          ;    
              incf       nomer,F
              incf       x_adr,F
              decfsz     temp,F
              goto       symb_3

              movlw      .0
              call       sendispdat          ;   (0x00)  
              incf       x_adr,F

              btfsc      flag,0
              goto       viv_4
         
              movlw      .10
              subwf      x_adr,F
              incf       y_adr,F
              movf       y_adr,W             ;    Y+1
              call       sendispcom 
              movf       x_adr,W             ;    X-10
              call       sendispcom 
              bsf        flag,0
              goto       symb_2

viv_4         decf       y_adr,F
              movf       y_adr,W          ;    Y-1
              call       sendispcom 

             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
tab_symb_1    movlw       high tab1         ;    
              movwf       PCLATH            ; 0-9
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
                                                  
tab1          dt 0xfc,0xfe,0x03,0x83,0xc3,0x63,0x33,0xfe,0xfc; 
              dt 0x0f,0x1f,0x33,0x31,0x30,0x30,0x30,0x1f,0x0f; '0'    ASCII  48
              dt 0x00,0x10,0x18,0x1c,0xfe,0xff,0x00,0x00,0x00; 
              dt 0x00,0x30,0x30,0x30,0x3f,0x3f,0x30,0x30,0x30; '1'
              dt 0x0c,0x0e,0x03,0x03,0x03,0x83,0xc3,0x7e,0x3c; 
              dt 0x30,0x38,0x3c,0x36,0x33,0x31,0x30,0x30,0x30; '2'
              dt 0x0c,0x0e,0x03,0xc3,0xc3,0xc3,0xc3,0xfe,0x3c; 
              dt 0x0c,0x1c,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; '3'
              dt 0xc0,0xe0,0xb0,0x98,0x8c,0x86,0x83,0xff,0xff; 
              dt 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x3f,0x3f; '4'
              dt 0x3f,0x7f,0x63,0x63,0x63,0x63,0x63,0xe3,0xc3; 
              dt 0x1c,0x3c,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '5'
              dt 0xfe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc7,0x86; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '6'
              dt 0x00,0x03,0x03,0x03,0x03,0x83,0xc3,0x7f,0x3f; 
              dt 0x00,0x00,0x00,0x3e,0x3f,0x01,0x00,0x00,0x00; '7'
              dt 0xbe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xbe; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '8'
              dt 0x7e,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xfe; 
              dt 0x18,0x38,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '9'   ASCII  57

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
tab_symb_2    movlw       high tab2         ;    
              movwf       PCLATH            ;  A-N
              movf        nomer,W           ;
              addlw       low tab2          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab2          dt 0xfc,0xfe,0xc3,0xc3,0xc3,0xc3,0xc3,0xfe,0xfc; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'A'    ASCII  65
 ;             dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x3c,0x3c; 
  ;            dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x0f,0x0f; 'B'

              dt 0x00,0x00,B'01000000',B'01000000',B'01000000',B'01000000',B'01000000',0x00,0x00; 'B'   "=" ()
             dt 0x00,0x00,B'00000001',B'00000001',B'00000001',B'00000001',B'00000001',0x00,0x00; 'B'   "=" ()
              dt 0xfc,0xfc,0x03,0x03,0x03,0x03,0x03,0x0c,0x0c; 
              dt 0x0f,0x0f,0x30,0x30,0x30,0x30,0x30,0x0c,0x0c; 'C'

 ;             dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
  ;            dt 0x00,0x00,0x00,0x3F,0x3F,0x01,0x01,0x01,0x00 ; 'D'   "" 

 ;            dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; ; 'D'     ""
  ;            dt 0x00,0x00,0x00,B'00111111',B'00111111',B'00001100',B'00011110',B'00110011',B'00100001'; ============ - "K"   ASCII = 75() = 4();;;;;;;;;;;;;;
;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    "h"     
;;;;;;;;;;
;           dt 0x00,B'01111111',B'01111111',B'00000001',B'00000001',B'00000001',B'00000001',B'01111111',B'01111111'; ; 'D'     "" 
;              dt 0x00,0x00,B'00111110',B'00111111',B'00001001',B'00001001',B'00111111',B'00111110',0x00; ============ - "K"   ASCII = 75() = 4();;;;;;;;;;;;;;

          dt 0x00,B'11111100',B'11111100',B'00000000',B'00000000',B'00000000',B'00000000',B'00000000',B'00000000'; ; 'D'     "h" 
          dt 0x00,B'00111111',B'00111111',B'00000001',B'00000001',B'00111111',B'00111110',B'00000000',0x00; ============ - "K"   ASCII = 75() = 4();;;;;;;;;;;;;;
;           dt B'11111111',B'11111111',B'01000000',B'01000000',B'01000000',B'01000000',B'01000000',B'11111111',B'11111111'; ; 'D'     "H" 
 ;          dt B'00111111',B'00111111',B'00000000',B'00000000',B'00000000',B'00000000',B'00000000',B'00111111',B'00111111'; ============ - "K"   ASCII = 75() = 4();;;;;;;;;;;;;;



;             dt 0x00,0x00,0xC0,0xC0,0x40,0x40,0xC0,0xC0,0x00  ; 
;             dt 0x00,0x00,0x3F,0x3F,0x00,0x00,0x3F,0x3F,0x00   ; 'E'  ""
 
              dt 0x00,B'11110000',B'11110000',B'00010000',B'00010000',B'00010000',B'00010000',B'11110000',B'11110000'  ; 
              dt 0x00,0x3F,0x3F,0x00,0x00,0x00,0x00,0x3F,0x3F   ; 'E'  ""

              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x3E,0x3F,0x09,0x09,0x3F,0x3E,0x00,0x00   ; 'F'   ""
              dt 0xfc,0xfe,0x03,0x03,0x83,0x83,0x83,0x8e,0x8c; 
              ;dt 0x0f,0x1f,0x30,0x30,0x31,0x31,0x31,0x1f,0x0f; 'G'
             ; dt 0xff,0xff,0xc0,0xc0,0xc0,0xc0,0xc0,0xff,0xff; 
             ; dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'H'
             ; dt 0x00,0x03,0x03,0xff,0xff,0x03,0x03,0x00,0x00; 
             ; dt 0x00,0x30,0x30,0x3f,0x3f,0x30,0x30,0x00,0x00; 'I'
             ; dt 0x00,0x00,0x00,0x03,0x03,0xff,0xff,0x03,0x03; 
              ;dt 0x0c,0x1c,0x30,0x30,0x30,0x1f,0x0f,0x00,0x00; 'J'
              ;dt 0xff,0xff,0xc0,0xe0,0x30,0x18,0x0c,0x07,0x03; 
             ; dt 0x3f,0x3f,0x00,0x01,0x03,0x06,0x0c,0x38,0x30; 'K' ;;;;;;;;;;;=========
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              ;dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x30,0x30; 'L'
              ;dt 0xff,0xff,0x06,0x0c,0x18,0x0c,0x06,0xff,0xff; 
             ; dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'M'
              ;dt 0xff,0xff,0x30,0x60,0xc0,0x80,0x00,0xff,0xff; 
              ;dt 0x3f,0x3f,0x00,0x00,0x00,0x01,0x03,0x3f,0x3f; 'N'   ASCII  78

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
tab_symb_3    movlw       high tab3         ;    
              movwf       PCLATH            ;  O-Z
              movf        nomer,W           ;
              addlw       low tab3          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
tab3    ;     dt 0x00, 0x3C,0x7E,0xC3,0xC3,0xC3,0xC3,0x7E,0x3C ; gradus
        ;      dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 'O'    ASCII  79

              dt 0x00,0x00,0x00,0x00,B'00001110',B'00010001',B'00010001',B'00010001',B'00001110' ; gradus
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 'O'    ASCII  79
;;; ,  ""     .
;              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00    ; 
;              dt 0x00,0x00,0x3F,0x3F,0x02,0x0C,0x02,0x3F,0x3F   ; 'P'    ""
              dt 0x00,0x00,B'01111110',B'01111110',B'00000100',B'00011000',B'00000100',B'01111110',B'01111110'  ; 
              dt 0x00,0x00,0x3F,0x3F,0x02,0x0C,0x02,0x3F,0x3F   ; 'P'   "" 

              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt  0x00,0x00,0x3F,0x3F,0x02,0x0C,0x02,0x3F,0x3F ; 'Q'     ""
  
;;             dt 0x00,0x00,0x00,B'0101010',B'0101010',0x00,B'11111110',B'11110001',B'11111110'; 
;;              dt B'00001110',B'00011101',B'00111100',B'00111101',B'00101110',B'00100000',B'00111111',B'00111111',B'00011111'; 'Q'     
																	; "Q"      
 ;;             dt 0x00,0x30,0x30,0x00,0x3F,0x3F,0x09,0x09,0x06 ; 'R'
 ;;             dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
 ;;             dt 0x00,0x30,0x30,0x00,0x1E,0x3F,0x21,0x21,0x12  ; 'S'
 ;;             dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
 ;;             dt 0x00,0x01,0x01,0x3F,0x3F,0x01,0x01,0x30,0x30  ; 'T'
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              ;dt 0x0f,0x1f,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; 'U'
              ;dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              ;dt 0x03,0x07,0x0c,0x18,0x30,0x18,0x0c,0x07,0x03; 'V'
              ;dt 0xff,0xff,0x00,0x00,0xff,0x00,0x00,0xff,0xff; 
              ;dt 0x0f,0x1f,0x30,0x30,0x1f,0x30,0x30,0x1f,0x0f; 'W'
              ;dt 0x07,0x0f,0x18,0xf0,0xe0,0xf0,0x18,0x0f,0x07; 
              ;dt 0x38,0x3c,0x06,0x03,0x01,0x03,0x06,0x3c,0x38; 'X'
              ;dt 0x3f,0x7f,0xc0,0xc0,0xc0,0xc0,0xc0,0x7f,0x3f; 
              ;dt 0x00,0x00,0x00,0x3f,0x3f,0x3f,0x00,0x00,0x00; 'Y'
              ;dt 0x03,0x03,0x03,0x83,0xc3,0x63,0x33,0x1f,0x0f; 
              ;dt 0x3c,0x3e,0x33,0x31,0x30,0x30,0x30,0x30,0x30; 'Z'    ASCII  90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
tab_symb_4    movlw       high tab4         ;    
              movwf       PCLATH            ;: , , ,  
              movf        nomer,W           ; , 
              addlw       low tab4          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab4          dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; ()  ASCII  32
              dt 0xc0,0xc0,0xc0,0xf8,0xf8,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x07,0x07,0x00,0x00,0x00,0x00; '+'  ASCII  43
              dt 0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; '-'  ASCII  45
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x3c,0x3c,0x3c,0x00,0x00,0x00; '.'  ASCII  46
              dt 0x00,0x1c,0x3e,0x63,0x63,0x63,0x3e,0x1c,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; (  , ) ASCII  176
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
paus          movlw       .7                ;  5,3 
              movwf       Sec1              ;
p_l2          movlw       .255              ;
              movwf       Sec               ;
p_l1          decfsz      Sec,F             ;
              goto        p_l1              ;
              decfsz      Sec1,F            ;
              goto        p_l2              ;
              return

;paus1s        movlw       .5                ;  1 
 ;           movwf       Sec2
;ps_3          movlw       .255              ;
 ;            movwf       Sec1              ;
;ps_2          movlw       .255              ;
 ;            movwf       Sec               ;
;ps_1          decfsz      Sec,F             ;
 ;            goto        ps_1              ;
  ;          decfsz      Sec1,F            ;
   ;        goto        ps_2              ;
    ;      decfsz      Sec2,F            ;
     ;    goto        ps_3 
      ;  return                        ;  



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP 

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP
	NOP
	NOP
	NOP
	NOP

	NOP 
	NOP 
	NOP 
	NOP 
	NOP 
	NOP
	NOP
	NOP
	NOP
	NOP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ʲ ί в 'Ҳ PIC16F648A, ˲ -  в ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SkynutyKontrBity	;   
	BCF		SPBKONTR_REGRR,7	;      .
	BCF		SPBKONTR_REGRR,6	;      .
	BCF		KONTR_REG,3		;     䳿   "(=0) - "
	BCF		KONTR_REG,7		;     䳿   "ϳ "
	LGOTO	SkynutyKontrBityKIN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ObrobkaNatKn	;   
;;; ֲ   ί     2,3 ( WDT), 
;;;      ,
;;;     (2,3 -  WDT)  򳺿     
;;;     .
;********************************************************************************************************
	BCF		LedZvuk			;     ,    
							;  ί  
;;;;;;;;;;;;;;;;;;;;;;;;
;  " " ;
;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSC	KnRegymZvuku		; PORTA,5	;  " "
	GOTO	NeZminjuvatyRegymZvuku		;

	BCF		MinusPidsv		;	PORTA,4	;  "-3 "()  ²  
									; (   2)

	BTFSC	SPBKONTR_REGRR,7		;   䳿 "  "  ,    
	GOTO	ZminuZvZakincheno		;
	BSF		SPBKONTR_REGRR,7	;      
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 
	LCALL	ZminaRegZvuku		;     :
									; - ( );
									; -  (      -  ;
									; -  .
	LGOTO	VyvidNygnjojiStroky
NeZminjuvatyRegymZvuku
ZminuZvZakincheno
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     "в Ĳֲ - " ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSC	KnRadTemperatura	;	PORTA,6	;  "г  -   "	
	GOTO	ZminuRegymRTZakincheno		;

	BCF		MinusPidsv		;	PORTA,4	;  "-3 "()  ²  
									; (   2)

	BTFSC	SPBKONTR_REGRR,6		;   䳿   "г  -   "  ,
 								;    
	GOTO	ZminuRegymRTZakincheno		;
	BSF		SPBKONTR_REGRR,6	;      
;;;;;;;;;;;;;;;;;;;;;;;;;;    
	BTFSS	SPBREG_IND,1	;     ,
	GOTO	ZvychZminaReg	;      ,     
							;        
	BCF		SPBREG_IND,1		;       ²
	MOVLW	B'00001100'			; Ҳ       
								; (       )
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 
	LCALL	sendispcom
	GOTO	ZminuRegymRTZakincheno		;
;;;;;;;;;;;;;;;;;;;;;;;;;;
ZvychZminaReg
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 

	LCALL	ZminaRegRT		;    : "г  -   "
	LGOTO	VyvidNygnjojiStroky
ZminuRegymRTZakincheno
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  "ϳ " ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSC	KnPidsv			; PORTA,3	;  "ϳ "
	GOTO	NeZminjuvatyRegymPidsvitky	
	BTFSC	KONTR_REG,7		;
	GOTO	NeZminjuvatyRegymPidsvitky		;
	BSF		Gyvl_LCD		; PORTA,0	;    (Ͳ -   i2c)
	BCF		MinusPidsv		;	PORTA,4	;  "-3 "()  ²  
									; (   2)

	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 

           Lcall        init_lcd          ;   
      Lcall        clear_lcd         ;   
	BSF		KONTR_REG,7		;     	
;      ,   
	BTFSS	SPBREG_IND,1	;
	GOTO	PozytZobr	;
	MOVLW	B'00001101'		;  
	LCALL	sendispcom		;    
PozytZobr
	LGOTO	bmp_1			;       			
;------------------------------------------------------------------------------
NeZminjuvatyRegymPidsvitky
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  ""   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	"",  WDT = 2,304.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	      "" - "" - "" -...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	,      . 
;
;;;;;;;;;;;;;;;;;;;;;;;;;
;   "" ;
;;;;;;;;;;;;;;;;;;;;;;;;;
	BTFSC	KnVysotaTysk		;	PORTA,2	;  "(=0) - "
	GOTO	BezZminyRegymu		;
	BCF		MinusPidsv		;	PORTA,4	;  "-3 "()  ²  
									; (   2)

	BTFSC	KONTR_REG,3			; 0/1 -    "(=0)-"  ² / ²
	GOTO	BezZminyRegymu		;

	BTFSS	SPBREG_IND,2		 ;2 - 0/1 -  ""  / ²
	GOTO	RegVysota	;
	BCF		SPBREG_IND,2		 ;2 - 0/1 -  ""  / ..........
	GOTO	RegTysk		;
RegVysota	;
	BSF		SPBREG_IND,2		 ;2 - 0/1 -  "" ........ / ²
RegTysk		;
	BSF		KONTR_REG,3			; 0/1 -    "(=0)-"  ² / ²
	LGOTO	bmp_1             ;   bmp_1
BezZminyRegymu		;
	BCF		SPBSTOR_POVERN,0	; ʲ,    0-   LGOTO     
	LGOTO	ObrobkaNatKnKIN	; ʲ   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;;;;;;;;;;;;;;     (   / Ĳֲ)
RegymPokazu		;      '
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  ֲ  ò,   
	MOVLW	D'50'
	BANK2
	SUBWF	B2SerRR,W
	BTFSS	STATUS,C
	BCF		SPBKONTR_REGRR,3
	BCF		SPBKONTR_REGRR,4	;   2-   
	BANK0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	 ,    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	(,     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;	  ,     !)
	BTFSS	KnPidsv			; PORTA,3	;  "ϳ "
	GOTO 	NeVYmykatyDysplay	;    "ϳ ",    
	BTFSC	FotoDatchyk				;   ,    
	GOTO 	NeVYmykatyDysplay

	BCF	Gyvl_LCD	;;    ;;
	BCF		SPBREG_IND,0	;   " "
NeVYmykatyDysplay
;;;;;;;;;;;;;;;;;;
; ί  ̲ުѲ   ί  ( . - в Ĳֲ   )
;    (SPBREG_IND,0 = 0),   
	BTFSS	SPBREG_IND,0		; 1 -  ²
	GOTO	RegRT_Obrano		; 0 -  
	
	BTFSC	SPBREG_IND,1	;           , 
	GOTO	RegRT_Obrano		;     (      T / RR )

	BTFSC	SPBREG_IND,3	;   ,    ("0")    ("1")
	GOTO	ZminytyNa0
	BSF		SPBREG_IND,3	;   ,    ("0")    ("1")
	GOTO	RegRT_Obrano
ZminytyNa0
	BCF		SPBREG_IND,3	;   ,    ("0")    ("1")
RegRT_Obrano
	LGOTO	RegymPokazuKIN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
PereryvchZv		;       2-   
;       2-   
	BTFSC	SPBKONTR_REGRR,0	;   " ",
	GOTO	BezSvZv				;    

	BTFSS	SPBKONTR_REGRR,4	;     2- , 
	GOTO	BezSvZv				;   
	BTFSC	KilPerWDT,0			;  
	BCF		LedZvuk				;
	BTFSS	KilPerWDT,0			;
	BSF		LedZvuk				;
BezSvZv
	LGOTO	PereryvchZvKIN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111

;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Pausa1Interval	;   1 
	LOADF	SPBPerer1,D'75'	;	
Povt2
	LOADF	SPBPerer2,D'255'	;	
Povt1		
	DECFSZ	SPBPerer2,F			;
	GOTO	Povt1

	DECFSZ	SPBPerer1,F			;
	GOTO	Povt2
;-----------------------------------------------------
;    1- в ί 'Ҳ,   
	BSF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Tryvoga			;   "" ( "SOS"  )
;	BANK2
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BSF		LedZvuk			;     -   
	LCALL	Pausa1Interval	;   1 
	BCF		LedZvuk			;     -   

	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
	LCALL	Pausa1Interval	;   1 
;-----------------------------
;	BANK0
;-----------------------------------------------------
;    1- в ί 'Ҳ,   
	BSF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
VyznSerRR		; ϲ  в Ĳֲ ϲ ̲ (5 )
; ²  ϲ ²:
;  ʲʲ ̲в,  ² B2KilxkVymRR = 0,  ò  ̲ B2NomerRegZapRR = 0
;
;  SPBLichylxnykIMP ( ),      B2VymRR1...12
;   B2SerRR (    )
;     (, .  25512 = 3060)    B2KilxkVymRR (..=12).
;       0...11,0...11,0...,
;     ,        .
;

	BANK2			;    ²  Ѳ ղͲ  ò
;   ò    ² B2VymRR1...12 (     0...11)
	MOVLW	D'12'		;    , ,   ,    
						;    (=11),        (=0)
	SUBWF	B2NomerRegZapRR,W
	BTFSS	STATUS,Z
	GOTO	NomerOK
	CLRF	B2NomerRegZapRR
NomerOK
; Ӫ ʲʲ ̲в,  ²,
;     (12,   5.),   ̲ު . 
	MOVLW	D'12'
	SUBWF	B2KilxkVymRR,W
	BTFSS	STATUS,Z
	INCF	B2KilxkVymRR,F	; ʲʲ ̲в,  ˲  12 (12  5. = 60. = 1 )
;  ò Ĳ   ̲  '  

	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3

	MOVLW	B2VymRR1		; 
	MOVWF	FSR
	MOVF_F	FSR,SPBPotFSR		;   FSR 
	MOVFW	B2NomerRegZapRR
	ADDWF	SPBPotFSR,F		;      ( B2NomerRegZapRR = 0,    B2VymRR1)	

	INCF	B2NomerRegZapRR,F	; Ӫ  ò   (  ̲)
; ²Ͳ ² ί  Ĳ ̲в  ò  ,  Ͳ,
; Ӫ ² Ͳ   ò    ί     ̲.
	MOVF_F	SPBPotFSR,FSR	;
	MOVF_F	INDF,TEMPB2	;   TEMPB2       .
	MOVFW	TEMPB2
	SUBWF	B2SumaVymRRG_ML,F
	BTFSS	STATUS,C
	DECF	B2SumaVymRRG_ST,F		; ²Ͳ ʲ

	MOVF_F	SPBPotFSR,FSR	;
	MOVF_F	SPBLichylxnykIMP,INDF	;    ò

	MOVFW	SPBLichylxnykIMP
	ADDWF	B2SumaVymRRG_ML,F
	BTFSC	STATUS,C
	INCF	B2SumaVymRRG_ST,F		;  ʲ

	CLRF	SPBLichylxnykIMP		;  ˲ Ѳ   ̲.

; ˲ Ӫ ͪ  в Ĳֲ
;       (B2SumaVymRRG_ST,B2SumaVymRRG_ML )
;   ,   (B2KilxkVymRR),
;         -  D'1'

Dilennja
	CLRF	B2SerRR	
;	CLRF	TEMPB2	;         
					;   ,      255 (. )
	MOVF_F	B2SumaVymRRG_ML,TEMPB2_ML		;       , 
	MOVF_F	B2SumaVymRRG_ST,TEMPB2_ST		;       

;	MOVLW	D'0'		;    0   -  !!!
;	XORWF	B2KilxkVymRR	;  !!!
;	BTFSC	STATUS,Z	;  !!!
;	GOTO	DilennjaKIN	;  !!!

ProdovgDilyty
	MOVF	B2KilxkVymRR,W		;
	SUBWF	TEMPB2_ML,F	;
	BTFSC	STATUS,C		;
	GOTO	ZbilxshRez		;
	MOVLW	D'1'			;
	SUBWF	TEMPB2_ST,F	;
	BTFSS	STATUS,C		;
	GOTO	DilennjaKIN		;
ZbilxshRez
	INCF	B2SerRR,F			;
	GOTO	ProdovgDilyty

;	INCFSZ	B2SerRR,F			; в   Ĳ  255,
;	GOTO	ProdovgDilyty		;  
;	INCF	TEMPB2,F		;   ² !!!
;	GOTO	ProdovgDilyty

DilennjaKIN
;  Ͳ  B2SerRR,
;   = 255 - TEMPB2_ML (   TEMPB2_ML    .   !!!)
	MOVFW	TEMPB2_ML
	SUBLW	0xFF	;
	MOVWF	TEMPB2_ML	;     òв TEMPB2_ML

	BCF	STATUS,C	;
	RRF	B2SerRR,W		;   W  0,5  

	SUBWF	TEMPB2_ML,W	;
	BTFSC	STATUS,C	; C=1 -->  ,    .
	INCF	B2SerRR,F		;	
;  ʲ  B2SerRR

;    -       1-    
	MOVLW	D'50'
	SUBWF	B2SerRR,W
	BTFSS	STATUS,C
	BCF		SPBKONTR_REGRR,2	;
;--------------------------------------------------------------------------------
	BANK0
	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
;-----------------------------------------------------
;    0- в ί 'Ҳ,   
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ObnulennjaDigits7_10		;   7...10,   1-,    0-
; ²Ͳ вͲ  ϲ
;-----------------------------------------------------
	CLRF	DIGIT7	;
	CLRF	DIGIT8	;
	CLRF	DIGIT9	;
	CLRF	DIGIT10	;
;-----------------------------------------------------
;    0- в ί 'Ҳ,   
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
VyvidStrBytesEEPROM		;     Ҳ  EEPROM. ղ   W , ² ʲӪ  StopByte 
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-----------------------------------------------------
	BANK1
	MOVWF	EEADR
NastByteEEPROM
	BSF		EECON1,RD	;   ""
	MOVF	EEDATA,W	; 
	BANK0
	MOVWF	TEMP1		;
	MOVLW	StopByte	;
	SUBWF	TEMP1,W		;
	BTFSC	STATUS,Z	;
	GOTO	VyvidStrBytesEEPROMKIN	;
	MOVFW	TEMP1				;
	LCALL	sendispdat			;
	BANK1
	INCF	EEADR,F				;
	GOTO	NastByteEEPROM		;
VyvidStrBytesEEPROMKIN
	BANK0
;-----------------------------------------------------
	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
;-----------------------------------------------------
;    0- в ί 'Ҳ,   
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
HV	;  ί   ˲
; ²Ͳ вͲ  ϲ
;-----------------------------------------------------
	BANK2
	LOADF	CYKLB2,D'6'
NAKACHKA
	LOADF	TEMPB2,D'255'
PACHKA
	LOADF	TEMPB2_ML,D'3'
	BANK0
	BSF		ImpHV		;        -
	BANK2
	DECFSZ	TEMPB2_ML,F
	GOTO	$-1
	BANK0
	BCF		ImpHV		;        -
	BANK2
	LOADF	TEMPB2_ST,D'13'
	DECFSZ	TEMPB2_ST,F
	GOTO	$-1

	DECFSZ	TEMPB2,F
	GOTO	PACHKA	
	DECFSZ	CYKLB2,F
	GOTO	NAKACHKA	
;
;-----------------------------
	BANK0
;-----------------------------------------------------
;    0- в ί 'Ҳ,   
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
SvZvIndImp		;  50     -21
;----------------------------------------------------
	LOADF	SPBPerer1,D'75'	; Ѳ ʲ ,    
	BSF		LedZvuk			;     -   
TRYMATY
	LOADF	SPBPerer2,D'255'	; Ѳ ʲ ,    
	DECFSZ	SPBPerer2,F		; Ѳ ʲ ,    
	GOTO	$-1
	DECFSZ	SPBPerer1,F		; Ѳ ʲ ,    
	GOTO	TRYMATY
	BCF		LedZvuk			;     -   
;-----------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111 

ZbilshLichGeigera	;       -21
	INCF	SPBFixatorIMP,F		; Ѳ ʲ ,     -21  
							;    WDT     ,          
							;  ""   SLEEP     .
	BTFSC	SPBKONTR_REGRR,4		;       (100 ? 99/),
	GOTO	ZbilshLichGeigKIN	;   Ͳ  ²Ӫ
	BANK2
;------------------------------------------------------------------------------------
; Ӫ ˲ Ѳ  ²ߪ   2-  (99/)
;------------------------------------------------------------------------------------
	INCF	SPBLichylxnykIMP,F		;       -

	MOVFW	SPBLichylxnykIMP		;     (5   -21)
	SUBLW	D'99'				;
;;	SUBLW	D'15'	; TTTTTTTTTTT
	BTFSS	STATUS,Z			;
	GOTO	RRNe255				;
	LOADF	B2SerRR,D'99'	;        99/
	CLRF	B2KilxkVymRR		;    ,   (. = 12)	
	CLRF	B2NomerRegZapRR	;       
;      ,      ,
;     ,    2- ,   

;;;;;;;;;     òв Ҳ ̲в в Ĳֲ   (12   5 )
	LOADF	SPBPerer1, D'12'		; 
	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3

	MOVLW	B2VymRR1		; 
	MOVWF	FSR
NAST_NUL_VymRR
	CLRF	INDF
	INCF	FSR,F			;
	DECFSZ	SPBPerer1,F
	GOTO	NAST_NUL_VymRR

	CLRF	B2SumaVymRRG_ML
	CLRF	B2SumaVymRRG_ST

	BSF		SPBKONTR_REGRR,4		;   2-  (99/)      ??????????
	BSF		SPBKONTR_REGRR,5		;        ,
								;           

	LCALL	Tryvoga			;   ""
RRNe255
; ²ߪ   1-  (50/)
	BTFSC	SPBKONTR_REGRR,3		;         1-  (=1),
	GOTO	TilxkyPysk			;    
	MOVFW	SPBLichylxnykIMP		;
	SUBLW	D'50'				;
;;	SUBLW	D'10'	;TTTTTTTTTTT
	BTFSS	STATUS,Z			;
	GOTO	TilxkyPysk			;
;;;;;;;;;;;;; 1- в 
; - ު      1-    
;				        ,     1- . 
; - ު    (     
;				 								    /  )
	BSF		SPBKONTR_REGRR,2	;      

	BSF		SPBREG_IND,1	;       ²

	LOADF	B2SerRR,D'50'	;        99/
	BSF		SPBKONTR_REGRR,3		;   1-  (50/)
	BSF		SPBREG_IND,3		;        (  )
	BSF		SPBKONTR_REGRR,5		;        ,
								;           
;-----------------------------
TilxkyPysk
; ²ߪ ղͲ ײ ²    ² ˲ -
	BTFSC	SPBKONTR_REGRR,0	; ,    " "
	GOTO	BezSygnalu		;
	MOVLW	B'00001110'		;      (1)
	ANDWF	SPBKONTR_REGRR,W	;    1-  (3),
								;      1-     (2)
	SUBLW	D'0'			;      " ",
	BTFSC	STATUS,Z		;    .
	GOTO	BezSygnalu		;	
	LCALL	SvZvIndImp		;  50     -21
	GOTO	ZbilshLichGeigKIN
BezSygnalu

	LCALL	PAUZA100ms	;  0,1., ,   ,
						;       !!!
ZbilshLichGeigKIN
	BANK0
;;; 	  Ҳ  ,  , Ҳ  0- в,  ů  
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;-----------------------------------------------------
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
PAUZA100ms				;        0,1
;	BANK0
	LOADF	SPBPerer1,D'5'	;	
M3
	LOADF	SPBPerer2,D'128'	;
M2
	LOADF	SPBPerer3,D'51'	;
M1
	DECFSZ	SPBPerer3,F             ;
	GOTO	M1              ;
	DECFSZ	SPBPerer2,F            ;
	GOTO	M2              ;
	DECFSZ	SPBPerer1,F            ;
	GOTO	M3 
	
;-------------------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN                        ;  
;-------------------------------------------------------------------------------------------------------

;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;   0- в ί 'Ҳ;;;;;;;;;
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
init_lcd
;--------------------------------------------------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-------------------------


      bcf        res_lcd           ;           
              nop
              nop
              bsf        res_lcd 
              nop
              nop 
                    
                         
              movlw      0x21              ;  , .,   
             Lcall       sendispcom        ;
              movlw      0x13              ;   Bias 1:48
              Lcall       sendispcom        ;
              movlw      0x04              ;   4
              Lcall       sendispcom
  ;;            movlw      0xC1              ;C1=B'11000001'  ( Vop) 6,42 (0B8)
 	MOVLW	B'11000000'   ;   LCD 5  (  LCD)
             Lcall       sendispcom
              movlw      0x20              ;  
              Lcall       sendispcom  
              movlw      0x0C              ; -   
              Lcall       sendispcom 
;------------
 	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
 ;------------	

	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
clear_lcd
;--------------------------------------------------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-------------------------

     movlw      0x40               ;  
              movwf      y_adr
              Lcall       sendispcom         ;    Y0
              movlw      0x80   
              movwf      x_adr           
              Lcall       sendispcom         ;    X0
              movlw      .6                 ; ,  504
              movwf      Sec1
povt4         movlw      .84
              movwf      Sec
povt3         movlw      .0
              Lcall       sendispdat         ;  0x00  
              decfsz     Sec,F              ;  504 
              goto       povt3              ;  
              decfsz     Sec1,F             
              goto       povt4
;------------
 	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
 ;------------	

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;        
; 32-      bin_HH, bin_HL, bin_LH, bin_LL
;      DIGIT1,    DIGIT10
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
bin2dec
;	bin_HH - HL - LH - LL	    
	BANK0
;--------------------------------------------------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
; ²Ͳ вͲ  ϲ
;--------------------------------------------------------------------------------------------------------
;	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
       bcf         flag,7            ;  
              btfss       bin_HH,7          ;   
              goto        bin2dec_1
              comf        bin_HH,F          ;   bin  
              comf        bin_HL,F          ;  
              comf        bin_LH,F
              comf        bin_LL,F
              incfsz      bin_LL,F
              goto        bin2dec_2
              incfsz      bin_LH,F
              goto        bin2dec_2
              incfsz      bin_HL,F
              goto        bin2dec_2
              incf        bin_HH,F
bin2dec_2     bsf         flag,7            ;  . 

bin2dec_1     clrf        DIGIT1            ;   . 
              clrf        DIGIT2
              clrf        DIGIT3
              clrf        DIGIT4
              clrf        DIGIT5
              clrf        DIGIT6
              clrf        DIGIT7
              clrf        DIGIT8
              clrf        DIGIT9
              clrf        DIGIT10            

              movlw       .32	             ;Loop counter
              movwf       count_1

b2dloop       rlf         bin_LL,F           ;Shift msb into carry
              rlf         bin_LH,F
              rlf         bin_HL,F
              rlf         bin_HH,F
    
              movlw       DIGIT10
              movwf       FSR                ;Pointer to digits
              movlw       .10                ;10 digits to do
              movwf       count_2

adjlp         rlf         INDF,F             ;Shift digit and carry 1 bit left
              movlw       .10
              subwf       INDF,W             ;Check and adjust for decimal overflow
              skpnc
              movwf       INDF

              decf        FSR,F	             ;Next digit
              decfsz      count_2,F
              goto        adjlp

              decfsz      count_1,F          ;Next bit
              goto        b2dloop
;------------------------------------------------------------------------------------------------------------------
 	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;------------	
	RETURN			; 
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysTysk_MM_binHH_LL_TaUtochnen	;     P_M...L    bin_LH...LL 
;												;   (  ( ..) = (-2)( ..))           
; ²Ͳ вͲ  ϲ
;-------------------------------------------------------------------------------------------
	BANK0	;       STATUS,RP0
              bsf         STATUS,RP0
              movf        P_M,W             ;   ( . )   bin 
              bcf         STATUS,RP0
              movwf       bin_LH
              bsf         STATUS,RP0
              movf        P_L,W
              bcf         STATUS,RP0
              movwf       bin_LL
;;;;;;;;;;    
;;;;;;;;;; (bin_LH,bin_LL) - 2  	
	MOVLW	D'2'		;
	SUBWF	bin_LL,F	;	
	BTFSS	STATUS,C	;
	DECF	bin_LH,F	;	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            clrf        bin_HL
              clrf        bin_HH
;------------------------------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;;;    0- в ί 'Ҳ,   .
;------------	
	RETURN			; 
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysTYSK_binHH_LL	;     P_HH...LL    bin_HH...LL            
; ²Ͳ вͲ  ϲ
;-------------------------------------------------------------------------------------------
	BANK0	;       STATUS,RP0
	bsf         STATUS,RP0        ;     bin
	movf        P_HH,W
	bcf         STATUS,RP0
	movwf       bin_HH
	bsf         STATUS,RP0
	movf        P_HL,W
	bcf         STATUS,RP0
	movwf       bin_HL
	bsf         STATUS,RP0
	movf        P_LH,W
	bcf         STATUS,RP0
	movwf       bin_LH
	bsf         STATUS,RP0
	movf        P_LL,W
	bcf         STATUS,RP0
	movwf       bin_LL

;-------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;;;    0- в ί 'Ҳ,   .
	RETURN
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysTEMP_binHH_LL	;     T_HH...LL    bin_HH...LL            
; ²Ͳ вͲ  ϲ
;--------------------------------------------------------------------------------------------------------
	BANK0	;       STATUS,RP0
	bsf         STATUS,RP0        ;     bin
	movf        T_HH,W
	bcf         STATUS,RP0
	movwf       bin_HH
	bsf         STATUS,RP0
	movf        T_HL,W
	bcf         STATUS,RP0
	movwf       bin_HL
	bsf         STATUS,RP0
	movf        T_LH,W
	bcf         STATUS,RP0
	movwf       bin_LH
	bsf         STATUS,RP0
	movf        T_LL,W
	bcf         STATUS,RP0
	movwf       bin_LL
;------------------------------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;------------	
;;;    0- в ί 'Ҳ,   .
	RETURN			; 
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysTyskDoRegistriv	;      P_HH...P_LL
; ²Ͳ вͲ  ϲ
;--------------------------------------------------------------------------------------------------------
	BANK0	;       STATUS,RP0
;	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
	movlw       data_i2c          ;    P
	movwf       FSR  
	bsf         STATUS,RP0  
	movf        INDF,W
	movwf       P_HL
	incf        FSR,F 
	movf        INDF,W
	movwf       P_LH
	incf        FSR,F 
	movf        INDF,W
	movwf       P_LL
	clrf        P_HH
	bcf         STATUS,RP0
	movf        oss,W             ;     P
	sublw       .8                ;    
	bsf         STATUS,RP0
	movwf       tmp
bmp_2
	bcf         STATUS,C
	rrf         P_HH,F
	rrf         P_HL,F
	rrf         P_LH,F
	rrf         P_LL,F
	decfsz      tmp,F
	goto        bmp_2
;------------------------------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;------------	
;;;    0- в ί 'Ҳ,   .
	RETURN			; 
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysTCelsDoRegistriv	;      T_HH...T_LL
; ²Ͳ вͲ  ϲ
;--------------------------------------------------------------------------------------------------------
	BANK0	;       STATUS,RP0
;	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
	movlw       data_i2c          ;    T
	movwf       FSR 
	bsf         STATUS,RP0   
	movf        INDF,W                       
	movwf       T_LH
	incf        FSR,F 
	movf        INDF,W
	movwf       T_LL
	bcf         STATUS,RP0          
	movlw       .0                ;    (16-19, 0-3(oss))
	movwf       oss
;------------------------------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
;;;    0- в ί 'Ҳ,   .
;------------	
	RETURN			; 
;1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
rd_temp		;        BMP180   I2C
			;   1-    0- 
;--------------------------------------------------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-------------------------
       movlw       0x2E              ;    
              movwf       data_i2c           
              goto        rd_bmp1
             
rd_pres		;      BMP180   I2C
			;   1-    0- 

;--------------------------------------------------------------------
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-------------------------

       movlw       0x34              ;       
              movwf       data_i2c          ;   
              movf        oss,W
              movwf       perem
              incf        perem,F
pres_2        decfsz      perem,F
              goto        pres_1
              goto        rd_bmp1

pres_1        movlw       0x40
              addwf       data_i2c,F
              goto        pres_2

rd_bmp1       movlw       .1                ;     I2C
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
;;              call        write_i2c         ;    I2C
	LCALL	write_i2c         ;    I2C
 
rd_bmp2
          movlw       .7                ;  5,3 
              movwf       Sec1              ;
M_l2          movlw       .255              ;
              movwf       Sec               ;
M_l1          decfsz      Sec,F             ;
              goto        M_l1              ;
              decfsz      Sec1,F            ;
              goto        M_l2              ;
;-------------------------------------------;
              movlw       .1                ;  
              movwf       tmp_i2c           ;    I2C
              movlw       0xF4              ;
              movwf       adr_i2c           ;      
 	LCALL	read_i2c          ;    I2C	
											;   0-    1- 
              movlw      data_i2c
              movwf      FSR 

              btfsc      INDF,5             ;   
              goto       rd_bmp2            ;  :    rd_bmp2

              movlw       .3                ;  
              movwf       tmp_i2c           ; 3-   I2C
              movlw       0xF6              ;
              movwf       adr_i2c           ;      

	LCALL	read_i2c          ;    I2C	
											;   0-    0-  1- 

;------------
 	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	
	RETURN			;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;              
ust_cur_1 
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 

		    movlw       0x40              ;    Y0
              movwf       y_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom
              goto        ust
ust_cur_2
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 

     movlw       0x41              ;    Y1
              movwf       y_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom
              goto        ust
ust_cur_3
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 
     movlw       0x42              ;    Y2
              movwf       y_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom
              goto        ust

ust_cur_4		;     1-  . '    
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 


     movlw       0x43              ;    Y3
              movwf       y_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom
              goto        ust
ust_cur_5
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1", 
								;       ,   ,
								;      ί 

     movlw       0x44              ;    Y4
              movwf       y_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
								;       ,   ,
								;       
	LCALL        sendispcom
              goto        ust

ust_cur_6     movlw       0x45              ;    Y5
              movwf       y_adr
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 

	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom
ust           movlw       0x80              ;    X0
              movwf       x_adr
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	LCALL        sendispcom

	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;

             return




;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZminaRegRT		;    : "г  -   "
; ²Ͳ вͲ  ϲ
;-------------------------------------------------------------------------------------------
	BTFSC	SPBREG_IND,3	; 0 -    / 1 -   
	GOTO	VstanovytyTGradC
	BSF		SPBREG_IND,3	;     
	GOTO	ZminaRegRTKIN
VstanovytyTGradC
	BCF		SPBREG_IND,3	;       
ZminaRegRTKIN
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZminaRegZvuku		;     :
; ²Ͳ вͲ  ϲ
;-------------------------------------------------------------------------------------------
	BTFSS	SPBKONTR_REGRR,0		; 1 - ,    - " ", 
								;   - " 
	GOTO	PotRegAboZvychAboZvImp
	BCF		SPBKONTR_REGRR,0		;
	BSF		SPBKONTR_REGRR,1		;   " "
	GOTO	VyhidZminaRegZvuku
PotRegAboZvychAboZvImp
	BTFSS	SPBKONTR_REGRR,1		; 1 - ,    - ", - ""
	GOTO	VstanovlBezZv		; 
	BCF		SPBKONTR_REGRR,0		;   ""
	BCF		SPBKONTR_REGRR,1		;    ""
	GOTO	VyhidZminaRegZvuku
VstanovlBezZv
	BCF		LedZvuk					;     ,   
	BSF		SPBKONTR_REGRR,0		;	
	BCF		SPBKONTR_REGRR,1		;   " "
VyhidZminaRegZvuku
	BSF		PCLATH,3		;  3-  4-     . '      ;;

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
InformPokaz		; .    ,       
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       

	MOVF_F	PotRezVymT,VidlikGraf	;        
	MOVLW	RezT24		; 
	MOVWF	FSR
	MOVF_F	FSR,SPBPotFSR	; Ѳ ʲ  -   FSR 24-, (24  )  
	BANK1
	LOADF	Y_GRAF,0x40
	BANK0

	LCALL	Grafik		;       VidlikGraf
;           (1(y_adr=040)  3(y_adr=042))
;   	STATUS,IRP
; IRP = 0 ,   ֲ Ӫ  ò  0  1
; IRP = 1 ,   ֲ Ӫ  ò  2  3
; ղͲ Ͳ:
; Y_GRAF -  y_adr    (1(y_adr=040)  3(y_adr=042))
; SPBPotFSR - FSR 24- ,         в Ĳֲ
; VidlikGraf -  ,      =  PotRezVymT ( )  B2SerRR ( в Ĳֲ)
; (     VerhByteGraf, NygnByteGraf)
	LCALL	ust_cur_1
        movlw       D'128'              ;    X0
            movwf       x_adr
           Lcall        sendispcom	;

	MOVFW	RezT1
	SUBWF	PotRezVymT,W
	BTFSS	STATUS,Z	;
	GOTO	TyskZminjuetxsja	;	

	LCALL	PogodaZaViknom		;   "  "

	GOTO	InformPokazKIN	;
TyskZminjuetxsja
	MOVFW	RezT1
	SUBWF	PotRezVymT,W
	BTFSS	STATUS,C	;
	GOTO	TyskZmenshuetxsja	;	
	LCALL	BudeSonjachno		;   " "
	GOTO	InformPokazKIN	;

TyskZmenshuetxsja

	LCALL	Doshchytyme		;   ""
InformPokazKIN
;  Ҳ     ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	BCF		SPBSTOR_POVERN,0		; 
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysDoMasRezRR		;        в Ĳֲ   
								; B2SerRR - Ͳ   (2 - BANK2).
; ²Ͳ вͲ  ϲ
	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3

	BANK2
	LOADF	CYKLB2,D'23'			;     
	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3
	MOVLW	B2SerRR23GT		;    23  
	MOVWF	FSR
	MOVF_F	FSR,SPBPotFSR	;   FSR      23  
ZapysujemoDali
	MOVF_F	INDF,TEMPB2;    TEMPB2 = B2SerRR23GT 
	INCF	SPBPotFSR,F	;
	MOVF_F	SPBPotFSR,FSR	;      FSR  24  
	MOVF_F	TEMPB2,INDF	;    B2RezRR24GT <---= B2SerRR23GT		
	DECF	SPBPotFSR,F	;
	DECF	SPBPotFSR,F	;       B2RezRR22GT
	MOVF_F	SPBPotFSR,FSR	;
	DECFSZ	CYKLB2,F	;
	GOTO	ZapysujemoDali

	MOVF_F	B2SerRR,B2SerRR1GT	;       

	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
	BANK0

;---------------------------------------------------------
;  Ҳ  0- в,   .
;---------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZapysDoMasRezT		;       (  . . - 700)    
; ²Ͳ вͲ  ϲ
	LOADF	CYKL,D'23'			;     
;	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1
	MOVLW	RezT23		; 
	MOVWF	FSR
	MOVF_F	FSR,SPBPotFSR	; Ѳ ʲ  -   FSR   		
ProdovgytyPerezapys
	MOVF_F	INDF,TEMP1;    TEMP1 = RezT23 
	INCF	SPBPotFSR,F	; Ѳ ʲ  -   FSR   	
	MOVF_F	SPBPotFSR,FSR	;
	MOVF_F	TEMP1,INDF	;    RezT24 = RezT23		
	DECF	SPBPotFSR,F	; Ѳ ʲ  -   FSR   	
	DECF	SPBPotFSR,F	;       RezT22
	MOVF_F	SPBPotFSR,FSR	;
	DECFSZ	CYKL,F	;
	GOTO	ProdovgytyPerezapys
	MOVF_F	PotRezVymT,RezT1	;       
;---------------------------------------------------------
;  Ҳ  0- в,   .
;---------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
VyznPotRezT		;     ( . . - 700)
				; .  - DIGIT9, DIGIT10, .  - PotRezVymT
; ²Ͳ вͲ  ϲ

	CLRF	PotRezVymT	
	MOVF	DIGIT9,F	; ,     . . 
	BTFSC	STATUS,Z	;
	GOTO	ODYNYCI	;
DESJATKY	
	MOVLW	D'10'	;
	ADDWF	PotRezVymT,F	;
	DECFSZ	DIGIT9,F
	GOTO	DESJATKY
ODYNYCI
	MOVFW	DIGIT10	;
	ADDWF	PotRezVymT,F	;
;  Ҳ     ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZsuvREGA_bin	;    REGA3--->bin_HL, REGA2--->bin_LH,REGA1--->bin_LL, '0'--->bin_HH 
; ²Ͳ вͲ  ϲ
	BANK1
	MOVFW	REGA3
	BANK0
	MOVWF	bin_HL
	BANK1
	MOVFW	REGA2
	BANK0
	MOVWF	bin_LH
	BANK1
	MOVFW	REGA1
	BANK0
	MOVWF	bin_LL
	CLRF	bin_HH	
;  Ҳ     ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
REGB_2158	;   "2158 = 00 00 08 6E"   REGB3...0 (REGB3,2 = "0", REGB1 = 0x08, REGB0 = 0x6E )
; ²Ͳ вͲ  ϲ
	BANK1
	CLRF	REGB3	;
	CLRF	REGB2	;
	MOVLW	0x08	;
	movwf	REGB1	;
	MOVLW	0x6E	;
	movwf	REGB0	;
;  Ҳ     ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Zapys_VidlAB_binAB	; (VidlVys_HH..._LL  bin_HH..._LL,  )--->REGA3...0
								; (VidlVys_HH..._LL  bin_HH..._LL,  )--->REGB3...0
	; (    ,        (VidlVys_...  bin_...))
;     180 - 1100,
;    2-   VidlVys_LH, VidlVys_LL

; ²Ͳ вͲ  ϲ
	BANK0
	CLRF	bin_HH	;
	CLRF	bin_HL	;		
	BANK1
	CLRF	REGA3	;
	CLRF	REGA2	;
	CLRF	REGB3	;
	CLRF	REGB2	;


	BANK0
PPEREVIRKA_LH	; 
	MOVFW	bin_LH	;
	SUBWF	VidlVys_LH,W	;
	BTFSC	STATUS,Z	;     ,   (   ) - 
	GOTO	PPEREVIRKA_LL	;    
;; 'Ӫ,   òв , bin_LH  VidlVys_LH
	MOVFW	bin_LH	;
	SUBWF	VidlVys_LH,W	;
	BTFSS	STATUS,C	; C = 1 => (f-w)  ( = "0" -  ), 
						;  VidlVys_LH > bin_LH,   .
	GOTO	TyskVidlikuMENSHE	; h = "-"(KONTR_REG,4 = '0')...,
					; bin_HH..._LL--->REGA3...0, VidlVys_HH..._LL--->REGB3...0. 
	GOTO	TyskVidlikuBILXSHE	; h = "+"(KONTR_REG,4 = '1')...,
					; VidlVys_HH..._LL--->REGA3...0, bin_HH..._LL--->REGB3...0.  



PPEREVIRKA_LL	; 	  bin_LH = VidlVys_LH
	MOVFW	bin_LL	;
	SUBWF	VidlVys_LL,W	;
	BTFSC	STATUS,Z	;     ,   (   ) - 
	GOTO	ChyslaOdnakovi	;  ², в = "0"
;; 'Ӫ,   òв , bin_LL  VidlVys_LL
	MOVFW	bin_LL	;
	SUBWF	VidlVys_LL,W	;
	BTFSS	STATUS,C	; C = 1 => (f-w)=(VidlVys...-bin...)  ( = "0" -  ), 
						;  VidlVys_LL > bin_LL,   .
	GOTO	TyskVidlikuMENSHE	; h = "-"(KONTR_REG,4 = '0')...,
					; bin_HH..._LL--->REGA3...0, VidlVys_HH..._LL--->REGB3...0. 
	GOTO	TyskVidlikuBILXSHE	; h = "+"(KONTR_REG,4 = '1')...,
					; VidlVys_HH..._LL--->REGA3...0, bin_HH..._LL--->REGB3...0.  
ChyslaOdnakovi	;  ², в = "0"
	BCF	KONTR_REG,6	;  0/1 -	      /   ("+"  "-")
	CLRF	DIGIT7	;
	CLRF	DIGIT8	;
	CLRF	DIGIT9	;
	CLRF	DIGIT10	;
	GOTO	KINZapys_VidlAB_binAB



TyskVidlikuBILXSHE	; h = "+"(KONTR_REG,4 = '1')...,
;					; VidlVys_HH..._LL--->REGA3...0, bin_HH..._LL--->REGB3...0.  
	BSF	KONTR_REG,6	;  0/1 -	      /   ("+"  "-")
	BSF	KONTR_REG,4	; 4 - 0/1 -      ("-") / ("+")

	BANK0
	MOVFW	VidlVys_LH	;
	BANK1
	MOVWF	REGA1
	BANK0
	MOVFW	VidlVys_LL	;
	BANK1
	MOVWF	REGA0	;

	BANK0
	MOVFW	bin_LH	;
	BANK1
	MOVWF	REGB1
	BANK0
	MOVFW	bin_LL	;
	BANK1
	MOVWF	REGB0	;
	GOTO	KINZapys_VidlAB_binAB

TyskVidlikuMENSHE	; h = "-"(KONTR_REG,4 = '0')...,
;					; bin_HH..._LL--->REGA3...0, VidlVys_HH..._LL--->REGB3...0.  
	BSF	KONTR_REG,6	;  0/1 -	      /   ("+"  "-")
	BCF	KONTR_REG,4	; 4 - 0/1 -      ("-") / ("+")

	BANK0
	MOVFW	bin_LH	;
	BANK1
	MOVWF	REGA1
	BANK0
	MOVFW	bin_LL	;
	BANK1
	MOVWF	REGA0	;

	BANK0
	MOVFW	VidlVys_LH	;
	BANK1
	MOVWF	REGB1
	BANK0
	MOVFW	VidlVys_LL	;
	BANK1
	MOVWF	REGB0	;

KINZapys_VidlAB_binAB

;      ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN	
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Zapys_binVidlVys	;          
	BANK0
;     180 - 1100,
;    2-   VidlVys_LH, VidlVys_LL

; ²Ͳ вͲ  ϲ
	MOVFW	bin_LH	
	MOVWF	VidlVys_LH
	MOVFW	bin_LL	
	MOVWF	VidlVys_LL
;      ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Zapys_Abin	;      bin_HH..._LL

; ²Ͳ вͲ  ϲ
	BANK1
	MOVFW	REGA3	;
	BANK0
	MOVWF	bin_HH	;
	BANK1
	MOVFW	REGA2	;
	BANK0
	MOVWF	bin_HL	;
	BANK1
	MOVFW	REGA1	;
	BANK0
	MOVWF	bin_LH	;
	BANK1
	MOVFW	REGA0	;
	BANK0
	MOVWF	bin_LL	;
;      ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Zapys_binA_100B	;   (bin_HH..._LL)  100, ,    
;   "divide"   REGA3...0(_HH..._LL) - ,    , REGB3...0(_HH..._LL) - 
;     1- ,     (   - bin_HH..._LL),    0- .  

; ²Ͳ вͲ  ϲ
	BANK0
	MOVFW	bin_HH	;
	BANK1
	MOVWF	REGA3
	BANK0
	MOVFW	bin_HL	;
	BANK1
	MOVWF	REGA2
	BANK0
	MOVFW	bin_LH	;
	BANK1
	MOVWF	REGA1
	BANK0
	MOVFW	bin_LL	;
	BANK1
	MOVWF	REGA0	;

	CLRF	REGB3	;
	CLRF	REGB2	;
	CLRF	REGB1	;

	MOVLW	D'100'	;
	BANK1
	MOVWF	REGB0	;	

;	LOADF	REGB0,D'100'	;
;  Ҳ  ί   ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
StartoveObnulennja	;      

; ²Ͳ вͲ  ϲ
	BANK2
	CLRF	B2SerRR			;       ,  
	CLRF	B2KilxkVymRR		;    ,   (. = 12)
	CLRF	B2NomerRegZapRR 	;     

	CLRF	B2SumaVymRRG_ST		;        
	CLRF	B2SumaVymRRG_ML		;        

;;;;;;;;;     òв Ҳ ̲в в Ĳֲ   (12   5 )
	LOADF	CYKLB2, D'12'		;         

	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3

	MOVLW	B2VymRR1		; 
	MOVWF	FSR
NAST_OBNUL_VymRR
	CLRF	INDF
	INCF	FSR,F			;
	DECFSZ	CYKLB2,F
	GOTO	NAST_OBNUL_VymRR
;;;;;;;;;     òв  Ͳ вͲ Ĳֲ  ,  
	LOADF	CYKLB2, D'24'		;         

	BSF		STATUS,IRP		; IRP = 1 ,   ֲ Ӫ  ò  2  3

	MOVLW	B2SerRR1GT		;    1  
	MOVWF	FSR
NAST_OBNUL_RRG
	CLRF	INDF
	INCF	FSR,F			;
	DECFSZ	CYKLB2,F
	GOTO	NAST_OBNUL_RRG
;-----------------------------------------------------------------
	BANK0
	CLRF	SPBKONTR_REGRR		; Ѳ ʲ 
 	CLRF	SPBLichylxnykIMP	; Ѳ ʲ       -
								;     (5   -21)
	CLRF	SPBREG_IND			; Ѳ ʲ   

	CLRF	SPBFixatorIMP		; Ѳ ʲ ,     -21   
								;    WDT     ,          
 
	CLRF	KONTR_REG			;

	CLRF	KilPerWDT		;    WDT,  ,    5 
							; 0,028  128 (.  )  130 = 299,52 = . 5.
	CLRF	GodynaZhvylyn	;     5- 


            clrf        flag              ;   
              clrf  x_adr
              clrf  y_adr


;;;;;;;;;     òв Ҳ ̲ 

	BCF		STATUS,IRP		; IRP = 0 ,   ֲ Ӫ  ò  0  1

	LOADF	CYKL, D'24'		;
	MOVLW	RezT1		; 
	MOVWF	FSR
NAST_CLRF
	CLRF	INDF
	INCF	FSR,F			;
	DECFSZ	CYKL,F
	GOTO	NAST_CLRF
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;11111111   
;  Ҳ     ',   .
	BCF		PCLATH,3		;  3-  4-     . '      ;;

	RETURN
;11111111111111111111111111111111111111111111111111111111111111222222222222222111111111111111111111111111111111111111
Grafik		;       VidlikGraf
;           (1(y_adr=040)  3(y_adr=042))
;   	STATUS,IRP
; IRP = 0 ,   ֲ Ӫ  ò  0  1
; IRP = 1 ,   ֲ Ӫ  ò  2  3
; ղͲ Ͳ:
; Y_GRAF -  y_adr    (1(y_adr=040)  3(y_adr=042))
; SPBPotFSR - FSR 24- ,         в Ĳֲ
; VidlikGraf -  ,      =  PotRezVymT ( )  B2SerRR ( в Ĳֲ)
; (     VerhByteGraf, NygnByteGraf)
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
	BANK1
	MOVF_F	Y_GRAF,y_adr
	BANK0
	LCALL        sendispcom	
	BANK1    
    movlw       D'148'              ;    X0+20
            movwf       x_adr
	BANK0
           Lcall        sendispcom	;
	LOADF	CYKL,D'24'			;     
VERH
	MOVF_F	INDF,RezMynGodyny	;    RezMynGodyny = RezT24
	LCALL	VerhByteGraf	;         (VidlikGraf)  
				;   (RezT1...RezT24  B2SerRR1GT...B2SerRR24GT), .  RezMynGodyny, .  - ByteGraf
	BTFSS	CYKL,0
	GOTO	PunktyrNULX
	BSF		ByteGraf,0	;    
	DECF	VidlikGraf,W	;   ,    
	SUBWF	RezMynGodyny,W	;     ( ),
	BTFSS	STATUS,Z		;     ,     .
	BSF		ByteGraf,7	;    
	GOTO	Punktyr1
PunktyrNULX
	BCF		ByteGraf,0	;    
	BTFSC	ByteGraf,6	;  6-  ,   7-   ,
						; , 7-  -   
	BCF		ByteGraf,7	;    
Punktyr1
	MOVFW	ByteGraf
	LCALL	sendispdat		;     	
	DECF	SPBPotFSR,F	; Ѳ ʲ  -   FSR   	
	MOVF_F	SPBPotFSR,FSR	; Ѳ ʲ  -   FSR   	
	DECFSZ	CYKL,F		;
	GOTO	VERH

	MOVLW	B'10000000'	; ,    
	LCALL	sendispdat	;       


	BANK1
	INCF	Y_GRAF,F
	MOVF_F	Y_GRAF,y_adr	; 
	BANK0
	LCALL        sendispcom	;    Բ
        movlw       D'148'              ;    X0+20
              movwf       x_adr
              Lcall        sendispcom	;
	LOADF	CYKL,D'24'			;     

	MOVLW	D'24'		; 
	ADDWF	SPBPotFSR,F	;  ò
	MOVF_F	SPBPotFSR,FSR	; Ͳ ̲ (24  )
NYZ
	MOVF_F	INDF,RezMynGodyny	;    RezMynGodyny = RezT24
	LCALL	NygnByteGraf	;         (VidlikGraf)  
				;   (RezT1...RezT24  B2SerRR1GT...B2SerRR24GT), .  RezMynGodyny, .  - ByteGraf
	BTFSS	CYKL,0
	BCF		ByteGraf,6	;    
	BTFSC	CYKL,0
	BSF		ByteGraf,6	;    
	MOVFW	ByteGraf
	LCALL	sendispdat		;     	
	DECF	SPBPotFSR,F	;
	MOVF_F	SPBPotFSR,FSR
	DECFSZ	CYKL,F		;
	GOTO	NYZ
	MOVLW	B'00101010'	;       
	LCALL	sendispdat	;       

	RRF		SPBSTOR_POVERN,F		;  ,     '   
								;       0-  . 
	BTFSC	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	BTFSS	SPBSTOR_POVERN,0		;       ' (0-  1-)  
								;   ;
	BCF		PCLATH,3		;  3-  4-     . '      ;;

	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
VerhByteGraf	;         (VidlikGraf)  
				;   (RezT1...RezT24  B2SerRR1GT...B2SerRR24GT), .  RezMynGodyny, .  - ByteGraf
;	RLF		SPBSTOR_POVERN,F		;  ,     '   
;								;      1- (  0- !!!) . 
;	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
; ²Ͳ вͲ  ϲ
; VidlikGraf -  ,      =  PotRezVymT ( )  B2SerRR ( в Ĳֲ)

	MOVF_F	VidlikGraf,TEMP1		;
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z	; Z=1 -   ,     
	GOTO	V1
	LOADF	ByteGraf,B'10000000'	;
	GOTO	KinVerhByteGraf			;
V1
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSC	STATUS,C	; C=1 -   (  =  ),       -   
	GOTO	V2			; 		      -    в
	CLRF	ByteGraf	;
	GOTO	KinVerhByteGraf			;
V2	
	INCF	TEMP1,F			;        + 1
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	V3				;
	LOADF	ByteGraf,B'11000000'	;
	GOTO	KinVerhByteGraf			;
V3
	INCF	TEMP1,F			;        + 2
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	V4				;
	LOADF	ByteGraf,B'11100000'	;
	GOTO	KinVerhByteGraf			;
V4
	INCF	TEMP1,F			;        + 3
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	V5				;
	LOADF	ByteGraf,B'11110000'	;
	GOTO	KinVerhByteGraf			;
V5
	INCF	TEMP1,F			;        + 4
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	V6				;
	LOADF	ByteGraf,B'11111000'	;
	GOTO	KinVerhByteGraf			;
V6
	INCF	TEMP1,F			;        + 5
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	V7				;
	LOADF	ByteGraf,B'11111100'	;
	GOTO	KinVerhByteGraf			;
V7
	LOADF	ByteGraf,B'11111110'	;      -    	

KinVerhByteGraf
;;;;;    1- в ί 'Ҳ,   
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
NygnByteGraf	;         (VidlikGraf)  
				;   (RezT1...RezT24  B2SerRR1GT...B2SerRR24GT), .  RezMynGodyny, .  - ByteGraf
; ²Ͳ вͲ  ϲ
;;;;;    1- в ί 'Ҳ,   
	MOVF_F	VidlikGraf,TEMP1		;
	DECF	TEMP1,F			;     ,    
;	DECF	TEMP1,F			;    111... ,      
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,C	; C=0 -  , 
	GOTO	N1			; 		      -    
	LOADF	ByteGraf,B'00111111'	;
	GOTO	KinNygnByteGraf			;
N1	
	DECF	TEMP1,F			;        - 2
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	N2				;
	LOADF	ByteGraf,B'00111110'	;
	GOTO	KinNygnByteGraf			;
N2
	DECF	TEMP1,F			;        - 3
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	N3				;
	LOADF	ByteGraf,B'00111100'	;
	GOTO	KinNygnByteGraf			;
N3
	DECF	TEMP1,F			;        - 4
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	N4				;
	LOADF	ByteGraf,B'00111000'	;
	GOTO	KinNygnByteGraf			;
N4
	DECF	TEMP1,F			;        - 5
	MOVFW	TEMP1
	SUBWF	RezMynGodyny,W	;
	BTFSS	STATUS,Z		;
	GOTO	N5				;
	LOADF	ByteGraf,B'00110000'	;
	GOTO	KinNygnByteGraf			;
N5
	LOADF	ByteGraf,B'00100000'	;      -    


KinNygnByteGraf	
;;;;;    1- в ί 'Ҳ,   
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
PokazPictogramVerhnStroky	;    
	RLF		SPBSTOR_POVERN,F		;  ,     '   
								;      1- (  0- !!!) . 
	BSF		SPBSTOR_POVERN,0		; ʲ,    1- , 0-    "1" 
								;       ,   ,
								;       
;-------------------------------------------------------------------------------------------
; ² ,     
	BTFSS	SPBKONTR_REGRR,0	;     " ",
	GOTO	NeBezZvRegYM			;     
	LCALL	ZnBezZv		;   " "
	GOTO	PodalxshyjVyvid	;

NeBezZvRegYM
	MOVLW	B'00011000'		;  3-  4-    1-  2-   SPBKONTR_REGRR
	ANDWF	SPBKONTR_REGRR,W	;
	SUBLW	D'0'			;
	BTFSC	STATUS,Z		; Z=0    
	GOTO	FonovyjRR
	LCALL	ZnRad		;    
	GOTO	PodalxshyjVyvid	;
FonovyjRR
	BTFSC	SPBKONTR_REGRR,1	;    ,
	GOTO	Pidzvuchka		;     

	LCALL	ZnFonRad		;   " "
	GOTO	PodalxshyjVyvid	;
Pidzvuchka
	LCALL	ZnZvImp		;   " "
PodalxshyjVyvid
	BTFSC	SPBREG_IND,3	;   ,    ("0")    ("1")
	GOTO	MKR
	GOTO	NOTMKR
MKR
	LCALL	SkorochennjaMKRG		;     
NOTMKR
;-------------------------------------------------------------------------------------------
	RRF		SPBSTOR_POVERN,F		;  ,     '   
; ;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BCF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZnFonRad		;   " "
;-------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_5		;
	CLRF	FSR
VyvidZnFonRadVerh	MOVLW	(FonRadVerhTbl	>>8)	; set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	LCALL	FonRadVerhTbl		;get current character   IN W !!!
	MOVWF	TEMP1
	MOVLW	StopByte
	SUBWF	TEMP1,W
	BTFSC	STATUS,Z
	GOTO	VyvidZnFonRadVerhKIN
	MOVFW	TEMP1
	LCALL	sendispdat		;
	GOTO	VyvidZnFonRadVerh
VyvidZnFonRadVerhKIN
	LCALL	ust_cur_6		; 
	CLRF	FSR
VyvidZnFonRadNyz	MOVLW	(FonRadNyzTbl	>>8)	; set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	LCALL	FonRadNyzTbl		;get current character   IN W !!!
	MOVWF	TEMP1
	MOVLW	StopByte
	SUBWF	TEMP1,W
	BTFSC	STATUS,Z
	GOTO	VyvidZnFonRadNyzKIN
	MOVFW	TEMP1
	LCALL	sendispdat		;
	GOTO	VyvidZnFonRadNyz
VyvidZnFonRadNyzKIN
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
BudeSonjachno		;   " "
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_1
;  ²  EEPROM
	MOVLW	0x00			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
	LCALL	ust_cur_2
	MOVLW	0x15			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
Doshchytyme		;   ""
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_1
	MOVLW	0x2A			;    .  ϲ ""
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
	LCALL	ust_cur_2
	MOVLW	0x3F			;    .  ϲ ""
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
PogodaZaViknom		;   "  "
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_1
	MOVLW	0x54			;    .  ϲ "  "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
	LCALL	ust_cur_2
	MOVLW	0x69			;    .  ϲ "  "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZnRad		;    
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_5		;
	MOVLW	0x7E			;    .  ϲ   -  
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
	LCALL	ust_cur_6		; 
	MOVLW	0x8E			;    .  ϲ   -  
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZnZvImp		;   " "
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_5		;
	MOVLW	0x9E			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
	LCALL	ust_cur_6		; 
	MOVLW	0xAE			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
ZnBezZv		;   " "
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_5		;
	MOVLW	0xBE			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
	LCALL	ust_cur_6		; 
	MOVLW	0xCE			;    .  ϲ " "
	LCALL	VyvidStrBytesEEPROM		;     Ҳ  EEPROM.
									; ղ   W , ² ʲӪ  StopByte 
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
SkorochennjaMKRG		;     
;-------------------------------------------------------------------------------------------
; 	ϲ   1- вֲ,    ί в,     
;-------------------------------------------------------------------------------------------
	LCALL	ust_cur_5		;
       movlw       D'193'              ;    X0
          movwf       x_adr
        Lcall        sendispcom	;	
	CLRF	FSR
VyvidMkRGVerh	MOVLW	(MkRGVerhTbl	>>8)	; set PCLATH to the high order address
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	LCALL	MkRGVerhTbl		;get current character   IN W !!!
	MOVWF	TEMP1
	MOVLW	StopByte
	SUBWF	TEMP1,W
	BTFSC	STATUS,Z
	GOTO	VyvidMkRGVerhKIN
	MOVFW	TEMP1
	LCALL	sendispdat		;
	GOTO	VyvidMkRGVerh
VyvidMkRGVerhKIN
	LCALL	ust_cur_6		; 
      movlw       D'193'              ;    X0
          movwf       x_adr
        Lcall        sendispcom	;	
	CLRF	FSR
VyvidMkRGNyz	MOVLW	(MkRGNyzTbl	>>8)	; set PCLATH to the high order address
	
	MOVWF	PCLATH		;of the table (bits 12:8)
	MOVF	FSR,W		;current index
	INCF	FSR,F		;next
	LCALL	MkRGNyzTbl		;get current character   IN W !!!
	MOVWF	TEMP1
	MOVLW	StopByte
	SUBWF	TEMP1,W
	BTFSC	STATUS,Z
	GOTO	VyvidMkRGNyzKIN
	MOVFW	TEMP1
	LCALL	sendispdat		;
	GOTO	VyvidMkRGNyz
VyvidMkRGNyzKIN
;-------------------------------------------------------------------------------------------
; 	   ί в,   
	BSF		PCLATH,3		;  3-  4-     . '      ;;
	RETURN
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	ORG	0xEC8
;	ORG	0xEC0
	ORG	0xFB0
;--------------------------------------------------------------------------------
MkRGVerhTbl			;   "  " 
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'11110000',B'11110000',B'00100000',B'01000000',B'00100000',B'11110000',B'11110000',B'00000000',B'11110000',B'11110000',B'00100000',B'11010000',B'00000000',B'11111110',B'11111110'
	DT	B'00010010',B'00010010',B'00011110',B'00001100',B'10101010'
MkRGVerhTblEnd
;;--------------------------------------------------------------------------------
;MkRGNyzTbl			;   "  "    в
;	ADDWF	PCL,F
;;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
;	DT	B'00000010',B'01111010',B'01111010',B'00001010',B'00001010',B'00000010',B'00110010',B'01111010',B'01001010',B'01111010',B'00110010',B'00000010',B'01000010',B'01110010',B'01001010'
;	DT	B'01111010',B'01111010',B'01000010',B'00000010',B'10101010'
;MkRGNyzTblEnd
;--------------------------------------------------------------------------------
MkRGNyzTbl			;   "  "       Ѳ в
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00011010',B'00111010',B'00100010',B'00100010',B'01111010',B'01111010',B'00000010',B'01110010',B'01111010',B'00101010',B'00101010',B'01111010',B'01110010',B'00000010',B'00110010'
	DT	B'01111010',B'01001010',B'01001010',B'01001010',B'10101010'
MkRGNyzTblEnd

;--------------------------------------------------------------------------------
FonRadVerhTbl			;   " " -  
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00001110',B'00001110',B'00001010',B'00011111',B'00011111',B'11001010',B'11101110',B'00101110',B'11100000',B'11000000',B'00000000',B'00000000',B'00000000'
	DT	B'00000000',B'00000000',B'10101010'
FonRadVerhTblEnd
;--------------------------------------------------------------------------------
FonRadNyzTbl				;   " " -  
	ADDWF	PCL,F
;        ,        > - - - - > - - - - > - - - - > - - - - > - - - - > - - - - > - - - -  > -  - - > - - - - - > (!)
	DT	B'00000000',B'00000000',B'00000000',B'00000000',B'00000000',B'00000001',B'00000011',B'00000010',B'00000011',B'00000001',B'01111100',B'01111100',B'00010000'
	DT	B'01111100',B'01111100',B'10101010'
FonRadNyzTblEnd
;--------------------------------------------------------------------------------
          end                           ;  
;#######################################################################################################
